function addaxes_fcn

h = get(0,'CurrentFigure');

%
% make sure we have a single left click from the mouse
% i.e. SelectionType=normal
%

st = get(h,'SelectionType');
if strcmp(st,'normal')==0;
   return;
end;

toolbar = get(h,'UserData');

%
% now we can create a new axes object
%

cp = get(h,'CurrentPoint');
%pos = get(toolbar.addtext,'Position');

%
% make sure current point is not to high
%

%if cp(2)>=pos(2)-40;
%   return;
%end;

%
% create an invisible axes
%

axes('Layer','top', ...
   'Units','pixels', ...
   'Position',[cp 1 1], ...
   'XLim',[0 1], ...
   'YLim',[0 1], ...
   'Tag','newaxes', ...
   'UserData',cp, ...
   'Visible','off');

%
% create 4 line to form a rectangle (these will be updated by the window button
% motion function
%

line('XData',[0 1],'YData',[0 0],'LineStyle',':','LineWidth',0.5);
line('XData',[0 0],'YData',[0 1],'LineStyle',':','LineWidth',0.5);
line('XData',[0 1],'YData',[1 1],'LineStyle',':','LineWidth',0.5);
line('XData',[1 1],'YData',[0 1],'LineStyle',':','LineWidth',0.5);

%
% Add new windowbuttonup, windowbuttondown, and windowbuttonmothion functions
%

set(h,'WindowButtonMotionFcn','update_axes_fcn');
set(h,'WindowButtonDownFcn','save_axes_fcn');
set(h,'WindowButtonUpFcn','save_axes_fcn');

%
% end of addaxes_fcn.m
%
