function addline_fcn

h = get(0,'CurrentFigure');

%
% make sure we have a single left click from the mouse
% i.e. SelectionType=normal
%

st = get(h,'SelectionType');
if strcmp(st,'normal')==0;
   return;
end;

toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% make sure where dealing with a proper axes
%

valid_axes = 0;
for i=1:size(myaxes,2);
   if gca==myaxes(1,i);
      valid_axes = 1;
      break;
   end;
end;

if valid_axes==0;
   return;
end;

%
% now we can create a new line object
%

cp = get(h,'CurrentPoint');
%pos = get(toolbar.addtext,'Position');

%
% make sure current point is not to high
%

%if cp(2)>=pos(2)-6;
%   return;
%end;

old_axes_units = get(gca,'Units');
set(gca,'Units','pixels');
axes_pos = get(gca,'Position');
set(gca,'Units',old_axes_units);

%
% make sure current point is accurate relative to the axes scale
%

axes_cp = get(gca,'CurrentPoint');
axes_cp = (axes_cp(1,:)+axes_cp(2,:))/2;

this_line = line('XData',axes_cp(1,1), ...
   'YData',axes_cp(1,2), ....
   'ZData',axes_cp(1,3), ...
   'LineStyle','-', ...
   'Color',[0 0 0], ...
   'Marker','none', ...
   'LineWidth',1, ...
   'Selection','on', ...
   'Tag',['nolegend-' num2str(axes_cp(1),'%0.0f') '-' num2str(axes_cp(2),'%0.0f') '-' num2str(axes_cp(3),'%0.0f')]);

set(toolbar.addline,'UserData',this_line);

%
% Add new windowbuttonup, windowbuttondown, and windowbuttonmothion functions
%

set(h,'WindowButtonMotionFcn','update_line_fcn');
set(h,'WindowButtonDownFcn','save_line_fcn');
set(h,'WindowButtonUpFcn','save_line_fcn');
set(h,'DoubleBuffer','on');

%
% end of addline_fcn.m
%
