function [as_series,as_quant,as_table] = asymp_series(df,test_var)

%
% constructing a series which can be displayed as the asymptotic distribution
%
% df is 1x1 or 1x2
% test_var is integer 0 or 1
%

as_quant = quantiles_fcn;
if test_var==1;
   as_table = fdist_inv(as_quant,df(1,1)*ones(size(as_quant)),df(1,2)*ones(size(as_quant)));
else;
   as_table = chisq_inv(as_quant,df(1,1)*ones(size(as_quant)));
end;
%
rand('state',sum(100*clock));
new_specification = rand(10000+50,1);
new_specification = sort(new_specification(51:10000+50,:));
%
as_series = zeros(10000,1);
for i=1:10000;
   for j=1:220;
      if new_specification(i,1)<=as_quant(j,1);
         as_series(i,1) = as_table(j,1);
         break;
      elseif j==220;
         as_series(i,1) = as_table(221,1);
      end;
   end;
end;

%
% end of asymp_series.m
%
