function [theta,Sigma_theta,beta,stdbeta,C,Sigma_C,num_c_rest,num_a_rest,infomat,abort] = c_restrict(Z0,Z1,Z2,restrict,beta,Theta,Rmat,rvec,p,pe,d,dcoint,q0,q1,modelsdir,modelfile,showwaitbar,reestbeta,R,r_vec)

theta = [];
Sigma_theta = [];
infomat = [];
abort = '';
num_c_rest = 0;
num_a_rest = 0;
Sigma_C = [];
C = [];

curr_ini = find_inisettings;

if nargin<17;
   showwaitbar = 0;
end;
if nargin<18;
   reestbeta = curr_ini.reestbeta;
end;

if nargin<20;
   R = [];
   r_vec = [];
end;

n = size(Theta,1);
r = size(beta,2);
T = size(Z0,2);
stdbeta = zeros(size(beta));

if curr_ini.convcrit<10;
   ch_convcrit = ['1.0e-00' num2str(curr_ini.convcrit)];
else;
   ch_convcrit = ['1.0e-0' num2str(curr_ini.convcrit)];
end;
ccrit = mystr2num(ch_convcrit);

Z3 = [];
alpha = [];
Psi = [];
if r>0;
   Z3 = beta'*Z1;
   alpha = Theta(:,size(Theta,2)-r+1:size(Theta,2));
end;
if isempty(Z2)==0;
   Z3 = [Z2;Z3];
   Psi = Theta(:,1:size(Theta,2)-r);
end;

epsilon = Z0-(Theta*Z3);
Omega = (1/T)*epsilon*epsilon';
oldOmega = Omega;

%
% evaluate all restrictions on Psi and alpha
%

if r<n;
   C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
else;
   C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
end;
xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
f_vec = (Rmat*vec(C))-rvec;
%
% pick up any alpha restrictions
%
if restrict(1,1)==1;
   %
   % collect alpha restrictions
   %
   file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
   G = loaddata(file);
   [Rmat_alpha,rvec_alpha] = rmatrix(G,n,r);
   if isempty(Z2)==0;
      Rmat_alpha = [zeros(size(G,1),size(Z2,1)*n) Rmat_alpha];
   end;
   Rmat_alpha = [R;Rmat_alpha];
   rvec_alpha = [r_vec;rvec_alpha];
   if rank(Rmat_alpha)<size(Rmat_alpha,1);
      [red_rest,use_rest] = getdelvars(Rmat_alpha',[]);
      Rmat_alpha = Rmat_alpha(use_rest,:);
      rvec_alpha = rvec_alpha(use_rest,1);
   end;
   f_vec = [(Rmat_alpha*vec(Theta))-rvec_alpha;f_vec];
else;
   Rmat_alpha = R;
   rvec_alpha = r_vec;
   if isempty(Rmat_alpha)==0;
      f_vec = [(Rmat_alpha*vec(Theta))-rvec_alpha;f_vec];
   end;
end;

%
% Determine the number of C restrictions
%

g_psi = [Rmat_alpha;Rmat*kron(xi',C)];
%
% check the rank of g_psi
%
if rank(g_psi)<size(g_psi,1);
   [red_rest,use_rest] = getdelvars(g_psi',[]);
   g_psi = g_psi(use_rest,:);
end;

num_c_rest = size(g_psi,1)-size(Rmat_alpha,1);
num_a_rest = size(Rmat_alpha,1);

if max(abs(f_vec))>ccrit;
   %
   % initialize beta restrictions if there are any
   %
   if (reestbeta==1)&(restrict(1,2)==1);
      %
      % Get the normalizing variables
      %
      file = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
      normvec = loaddata(file);
      I_mat = eye(size(beta,1));
      h = [];
      H = [];
      tot_free = 0;
      %
      % get restrictions on beta
      %
      for i=1:r;
         file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
         if fileexist(file)==1;
            H_i = loaddata(file);
            %
            % determine which rows in H_i are linearly independend
            %
            H_fix = H_i(normvec(i),:);
            j = 1;
            while j<=size(H_i,1);
              if size(H_fix,1)<size(H_fix,2);
                 if j~=normvec(i);
                    H_test = [H_fix;H_i(j,:)];
                    if rank(H_test)==size(H_test,1);
                       H_fix = H_test;
                    end;
                 end;
                 j = j+1;
              else;
                 j = size(H_i,1)+1;
              end;
            end;
            H_i = H_i/H_fix;
            h_i = H_i(:,1);
            h = [h;h_i];
            if size(H_i,2)>1;
               H_i = H_i(:,2:size(H_i,2));
            else;
               H_i = [];
            end;
            H_struc.elem(i).H_i = H_i;
            H_struc.elem(i).tot_free = tot_free;
            tot_free = tot_free+size(H_i,2);
         end;
      end;
      %
      % now we construct H from the above info
      %
      for i=1:r;
         if isempty(H_struc.elem(i).H_i)==1;
            H = [H;zeros(size(beta,1),tot_free)];
         else;
            H_i = H_struc.elem(i).H_i;
            my_free = H_struc.elem(i).tot_free;
            if my_free>0;
               H_first = zeros(size(beta,1),my_free);
            else;
               H_first = [];
            end;
            if tot_free-(my_free+size(H_i,2))>0;
               H_last = zeros(size(beta,1),tot_free-(my_free+size(H_i,2)));
            else;
               H_last = [];
            end;
            H = [H;[H_first H_i H_last]];
         end;
      end;
   end;
   %
   % matrices needed to compute the gradient wrt beta
   %
   M_10 = (1/T)*Z1*Z0';
   M_11 = (1/T)*Z1*Z1';
   if isempty(Z2)==0;
      M_12 = (1/T)*Z1*Z2';
      M_22 = (1/T)*Z2*Z2';
   else;
      M_12 = [];
      M_22 = [];
   end;
   %
   % we need to estimate C under restrictions
   %
   max_val = max(abs(f_vec));
   it = 0;
   psi = vec(Theta);
   %
   % setup a waitbar
   %
   if showwaitbar==1;
      input_var.title = ['Progress for maximum of ' int2str(curr_ini.maxit) ' iterations'];
      input_var.facecolor = curr_ini.progress_facecolor;
      input_var.startfacecolor = curr_ini.progress_startfacecolor;
      input_var.edgecolor = curr_ini.progress_edgecolor;
      input_var.bgcolor = curr_ini.progress_bgcolor;
      input_var.stop = 1;
      input_var.clock = 1;
      input_var.name = 'ML Estimation under Restrictions on C';
      mywait = progressdlg(0,input_var);
%      set(mywait,'Name','ML Estimation under Restrictions on C');
      set(mywait,'Color',get(0,'defaultuicontrolbackgroundcolor'));
      drawnow;
   end;
   %
   while (max_val>ccrit)&(it<curr_ini.maxit);
      it = it+1;
      ZZ_inv = (Z3*Z3')\eye(size(Z3,1));
      %
      % adjust waitbar if we update beta
      %
      if (showwaitbar==1)&(reestbeta==1)&(r>0);
         abort = get(mywait,'UserData');
         if (strcmp(abort,'cancel')==1)|(strcmp(abort,'done')==1);
            break;
         else;
            progressdlg([it/curr_ini.maxit max_val]);
         end;
      end;
      %
      it_psi = 0;
      while (max_val>ccrit)&(it_psi<curr_ini.maxit);
         it_psi = it_psi+1;
         %
         % adjust the waitbar if we don't update beta
         %
         if (showwaitbar==1)&((reestbeta==0)|(r==0));
            abort = get(mywait,'UserData');
            if (strcmp(abort,'cancel')==1)|(strcmp(abort,'done')==1);
               break;
            else;
               progressdlg([it_psi/curr_ini.maxit max_val]);
            end;
         end;
         %
         % estimate Psi and alpha under restrictions
         %
         g_psi = [Rmat_alpha;Rmat*kron(xi',C)];
         %
         % check the rank of g_psi
         %
         if rank(g_psi)<size(g_psi,1);
            [red_rest,use_rest] = getdelvars(g_psi',[]);
            g_psi = g_psi(use_rest,:);
            f_vec = f_vec(use_rest,1);
         end;
         %
         psi_adj_part1 = kron(ZZ_inv,Omega)*g_psi';
         psi_adj_part2 = (g_psi*psi_adj_part1)\eye(size(g_psi,1));
         psi_adj = psi_adj_part1*psi_adj_part2*f_vec;
         %
         psi = psi-psi_adj;
         %
         % reconstruct matrices
         %
         theta = vecinv(psi,n);
         if r>0;
            alpha = theta(:,size(theta,2)-r+1:size(theta,2));
         else;
            alpha = [];
         end;
         if isempty(Z2)==0;
            Psi = theta(:,1:size(theta,2)-r);
         else;
            Psi = [];
         end;
         epsilon = Z0-(theta*Z3);
         Omega = (1/T)*epsilon*epsilon';
         if r<n;
            C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
         else;
            C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
         end;
         xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
         f_vec = (Rmat*vec(C))-rvec;
         if isempty(Rmat_alpha)==0;
            f_vec = [(Rmat_alpha*vec(theta))-rvec_alpha;f_vec];
         end;
         max_val = max(abs(f_vec));
      end;
      %
      % update beta if asked for
      %
      if (reestbeta==1)&(restrict(1,2)==1);
         %
         % estimate the free beta coefficients for the first time
         %
         if rank(Omega,eps)<size(Omega,1);
            if rank(oldOmega,eps)<size(oldOmega,1);
               inv_Omega = eye(n);
            else;
               inv_Omega = oldOmega\eye(n);
            end;
         else;
            inv_Omega = Omega\eye(n);
         end;
         %
         m_1 = H'*kron(alpha'*inv_Omega*alpha,M_11)*H;
         m_2 = H'*kron(alpha'*inv_Omega,I_mat);
         if isempty(M_12)==0;
            c_1 = vec((M_10-(M_12*Psi')));
         else;
            c_1 = vec(M_10);
         end;
         c_2 = kron(alpha,M_11)*h;
         phi = m_1\(m_2*(c_1-c_2));
         v_beta = h+(H*phi);
         beta = vecinv(v_beta,size(beta,1));
         %
         % evaluate everything under the new beta
         %
         Z3 = [Z2;beta'*Z1];
         %
         epsilon = Z0-(theta*Z3);
         Omega = (1/T)*epsilon*epsilon';
         %
         if r<n;
            C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
         else;
            C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
         end;
         xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
         f_vec = (Rmat*vec(C))-rvec;
         if isempty(Rmat_alpha)==0;
            f_vec = [(Rmat_alpha*vec(theta))-rvec_alpha;f_vec];
         end;
         %
         max_val = max(abs(f_vec));
      elseif (reestbeta==1)&(restrict(1,2)==0)&(r>0);
         %
         % re-estimate beta
         %
         if isempty(Z2)==0;
            beta = inverse(M_11)*(M_10-(M_12)*Psi')*inverse(Omega)*alpha*inverse(alpha'*inverse(Omega)*alpha);
         else;
            beta = inverse(M_11)*M_10*inverse(Omega)*alpha*inverse(alpha'*inverse(Omega)*alpha);
         end;
         %
         % evaluate everything under the new beta
         %
         Z3 = [Z2;beta'*Z1];
         %
         epsilon = Z0-(theta*Z3);
         Omega = (1/T)*epsilon*epsilon';
         %
         if r<n;
            C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0);
         else;
            C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,0,[]);
         end;
         xi = xi_mat(C,Psi,alpha,p,pe,r,d,q1,q0);
         f_vec = (Rmat*vec(C))-rvec;
         %
         max_val = max(abs(f_vec));
      end;
      %
      infomat = [it max_val];
   end;
   %
   % delete waitbar
   %
   if showwaitbar==1;
      set(mywait,'UserData','done');
      close(mywait);
      drawnow;
   end;
   %
   % remake Sigma_theta
   %
   ZZ_inv = (Z3*Z3')\eye(size(Z3,1));
   ZZ_Omega = kron(ZZ_inv,Omega);
   g_psi = [Rmat_alpha;Rmat*kron(xi',C)];
   %
   % check the rank of g_psi
   %
   if rank(g_psi)<size(g_psi,1);
      [red_rest,use_rest] = getdelvars(g_psi',[]);
      g_psi = g_psi(use_rest,:);
   end;
   part1_adj = g_psi*ZZ_Omega;
   part2_adj = part1_adj*g_psi';
   Sig_theta_adj = part1_adj'*(part2_adj\part1_adj);
   Sigma_theta = ZZ_Omega-Sig_theta_adj;
   %
   % remake stdbeta
   %
   if (reestbeta==1)&(restrict(1,2)==1);
      if rank(Omega,eps)<size(Omega,1);
         if rank(oldOmega,eps)<size(oldOmega,1);
            inv_Omega = eye(n);
         else;
            inv_Omega = oldOmega\eye(n);
         end;
      else;
         inv_Omega = Omega\eye(n);
      end;
      if isempty(Z2)==0;
         newR0 = Z0-((Psi+(alpha*beta'*(M_12/M_22)))*Z2);
         newR1 = Z1-((M_12/M_22)*Z2);
      else;
         newR0 = Z0;
         newR1 = Z1;
      end;
      %
      % Constructing unrestricted beta estimate
      %
      S_00_new = (1/T)*newR0*newR0';
      S_10_new = (1/T)*newR1*newR0';
      S_11_new = (1/T)*newR1*newR1';
      S_01_new = (1/T)*newR0*newR1';
      alpharort = null(alpha');
      S_11_alpha = S_11_new-(S_10_new*alpharort*((alpharort'*S_00_new*alpharort)\(alpharort'*S_01_new)));
      %
      sivec = zeros(r,1);
      %
      % bH is needed to check the gradient of the likelihood function
      % wrt the beta parameters
      %
      for i=1:r;
         file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
         if fileexist(file)==1;
            h = loaddata(file);
            if i==1;
               H = h;
               bH = h;
            else;
               H = [H h];
               bH = [[bH zeros(size(bH,1),size(h,2))];[zeros(size(h,1),size(bH,2)) h]];
            end;
            sivec(i,1) = size(h,2);
         end;
      end;
      %
      % Get the normalizing variables
      %
      file = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
      if fileexist(file)==1;
         normvec = loaddata(file);
      else;
         normvec = [];
      end;
      %
      % recompute ths conditional standard errors for beta
      %
      for i=1:r;
         %
         % Selecting the restrictions from H
         %
         si = sivec(i,1);
         if si>=2;
            sj = size(H,2);
            if i==1;
               Hsel = [eye(si);zeros(sj-si,si)];
            elseif i==r;
               Hsel = [zeros(sj-si,si);eye(si)];
            else;
               sk = sivec(1,1);
               for j=2:i-1;
                  sk = sk+sivec(j,1);
               end;
               Hsel = [zeros(sk,si);eye(si);zeros(sj-si-sk,si)];
            end;
            Hi = H*Hsel;
            %
            % Determining the normalizations
            %
            normelem = normvec(i,1);
            myexit = 0;
            for j=1:si;
               %
               % Fix Hi to make sure that the normalizing row
               % contains one unit element and zeros
               %
               normmatrix = Hi(normelem,:);
               for k=1:(n+q1+dcoint);
                  if k~=normelem;
                     checkHi = [normmatrix;Hi(k,:)];
                     if rank(checkHi*checkHi')==size(checkHi,1);
                        normmatrix = checkHi;
                        if size(normmatrix,1)==size(Hi,2);
                           break;
                        end;
                     end;
                  end;
               end;
               Hi = Hi/normmatrix;
               check = Hi(normelem,j);
               if (abs(check)>0)&(check~=1);
                  Hi(:,j) = (1/Hi(normelem,j))*Hi(:,j);
                  check = Hi(normelem,j);
               end;          
               if check==1;
                  %
                  % Split Hi into hi and H_i
                  %
                  if j==1;
                     hi = Hi(:,1);
                     H_i = Hi(:,2:si);
                  elseif j==si;
                     hi = Hi(:,si);
                     H_i = Hi(:,1:si-1);
                  else;
                     hi = Hi(:,j);
                     H_i = [Hi(:,1:j-1) Hi(:,j+1:si)];
                  end;
                  %
                  % Check H_i to make sure it is of full rank
                  %
                  check2 = H_i'*H_i;
                  if abs(det(check2))>=.000000001;
                     myexit=1;
                  end;
               end;
               if myexit==1;
                  break;
               end;
            end;
            %
            % Computing the asymptotic covariance for the
            % si-1 free parameters of column i in betar
            %
            information = alpha(:,i)'*inv_Omega*alpha(:,i)*H_i'*S_11_alpha*H_i;
            covbeta = (1/T)*(H_i/information)*H_i';
            %
            % Computing the asyptotic standard errors and
            % including them in stdbeta
            %
            stdbeta(:,i) = sqrt(abs(diag(covbeta)));
         end;
      end;
   end;
else;
   %
   % remake Sigma_theta
   %
   ZZ_inv = (Z3*Z3')\eye(size(Z3,1));
   ZZ_Omega = kron(ZZ_inv,Omega);
   g_psi = [Rmat_alpha;Rmat*kron(xi',C)];
   %
   % check the rank of g_psi
   %
   if rank(g_psi)<size(g_psi,1);
      [red_rest,use_rest] = getdelvars(g_psi',[]);
      g_psi = g_psi(use_rest,:);
   end;
   part1_adj = g_psi*ZZ_Omega;
   part2_adj = part1_adj*g_psi';
   Sig_theta_adj = part1_adj'*(part2_adj\part1_adj);
   Sigma_theta = ZZ_Omega-Sig_theta_adj;
end;

if r<n;
   [C,Sigma_C] = cmat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,1,Sigma_theta);
else;
   [C,Sigma_C] = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,1,Sigma_theta);
end;

%
% end of c_restrict.m
%
