function [C,Sigma_c,dC_b,Sigma_b] = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,p,d,ind,Sigma_pi)

if nargin<10;
   Sigma_pi = [];
end;

[n T] = size(epsilon);

%
% need to convert alpha and beta
%

beta_base = beta(1:n,:);
beta = beta/beta_base;
alpha = alpha*beta_base';

Pi_mat = -alpha;
C = Pi_mat\eye(n);

if ind==1;
   nr = size(Z2,1);
   Omega = (1/T)*epsilon*epsilon';
   %
   % Compute the asymptotic covariance matrix of C
   %
   if isempty(Sigma_pi)==1;
      selRow = [zeros(n,nr) eye(n)];
      if p>=2;
         selRow = [[zeros(n*(p-1),d) eye(n*(p-1)) zeros(n*(p-1),nr+n-d-(n*(p-1)))];selRow];
      end;
      if isempty(Z2)==0;
         Z3 = [Z2;beta'*Z1];
      else;
         Z3 = beta'*Z1;
      end;
      inv_zz = eye(nr+n)/(Z3*Z3');
      inv_zz = selRow*inv_zz*selRow';
      Sigma_pi = kron(inv_zz,Omega);
   end;
   deriv = kron(C',C);
   num = size(Sigma_pi,1);
   Sigma_C = deriv*(Sigma_pi(num-(n*n)+1:num,num-(n*n)+1:num))*deriv';
   if nargout>=2;
      Sigma_c = Sigma_C;
      if nargout==4;
         if p>1;
            J = [zeros(n,n*(p-1)) eye(n)];
         else;
            J = eye(n);
         end;
         dC_b = kron(C'*J,C);
         Sigma_b = Sigma_pi(n*d+1:size(Sigma_pi,1),n*d+1:size(Sigma_pi,1));
      end;
   else;
      CStd = abs(sqrt(diag(Sigma_C)));
      CStd = vecinv(CStd,n);
      C = [C CStd];
   end;
else;
   if nargout>=2;
      Sigma_c = [];
      if nargout==4;
         dC_b = [];
         Sigma_b = [];
      end;
   end;
end;

%
% end of cmat_stat.m
%
