function copy_patch_fcn

curr_patch = gco;
patch_prop.xdata = get(curr_patch,'XData');
patch_prop.ydata = get(curr_patch,'YData');
patch_prop.zdata = get(curr_patch,'ZData');
patch_prop.linestyle = get(curr_patch,'LineStyle');
patch_prop.linewidth = get(curr_patch,'LineWidth');
patch_prop.tag = get(curr_patch,'Tag');
patch_prop.edgecolor = get(curr_patch,'EdgeColor');
patch_prop.facecolor = get(curr_patch,'FaceColor');
patch_prop.cdata = get(curr_patch,'CData');
patch_prop.cdatamapping = get(curr_patch,'CDataMapping');
patch_prop.ambientstrength = get(curr_patch,'AmbientStrength');
patch_prop.backfacelighting = get(curr_patch,'BackFaceLighting');
patch_prop.diffusestrength = get(curr_patch,'DiffuseStrength');
patch_prop.edgelighting = get(curr_patch,'EdgeLighting');
patch_prop.facelighting = get(curr_patch,'FaceLighting');
patch_prop.specularcolorreflectance = get(curr_patch,'SpecularColorReflectance');
patch_prop.specularexponent = get(curr_patch,'SpecularExponent');
patch_prop.specularstrength = get(curr_patch,'SpecularStrength');
patch_prop.marker = get(curr_patch,'Marker');
patch_prop.markersize = get(curr_patch,'MarkerSize');
patch_prop.markeredgecolor = get(curr_patch,'MarkerEdgeColor');
patch_prop.markerfacecolor = get(curr_patch,'MarkerFaceColor');
patch_prop.clipping = get(curr_patch,'Clipping');

fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
copy = get(model.run,'UserData');

update_figs = 0;
if isfield(copy,'patch_properties')==0;
   update_figs = 1;
end;
copy.patch_properties = patch_prop;
set(model.run,'UserData',copy);

%
% update all open figure such that pasting of lines are enabled
%

if update_figs==1;
   my_figs = sort(findobj(0,'Type','figure')');
   for i=1:size(my_figs,2);
      this_toolbar = get(my_figs(1,i),'UserData');
      if isempty(this_toolbar)==0;
         %
         % make sure we're not dealing with a program figure
         %
         if isfield(this_toolbar,'renderer')==1;
            myaxes = get(this_toolbar.print,'UserData');
            for j=1:size(myaxes,2);
               patch_menu = findobj(get(myaxes(1,j),'UIContextMenu'),'Label','Patch')';
               if isempty(patch_menu)==0;
                  set(patch_menu,'Enable','on');
               end;
            end;
         end;
      end;
   end;
end;

%
% end of copy_patch_fcn.m
%
