function delete_colorbar_fcn(this_colorbar,only_this_axes);

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

if nargin==0;
   this_colorbar = findobj(h,'Type','axes','Tag','colorbar')';
   only_this_axes = [];
elseif nargin==1;
   only_this_axes = [];
end;

%
% make sure settings hold for all colorbars
%

for j=1:size(this_colorbar,2);
   curr_axes = get(this_colorbar(1,j),'UserData');

   if ((isempty(only_this_axes)==1)|(only_this_axes==curr_axes))&(ishandle(curr_axes)==1);
      %
      old_cunits = get(this_colorbar(1,j),'Units');
      set(this_colorbar(1,j),'Units','pixels');
      colorbar_pos = get(this_colorbar(1,j),'Position');
      set(this_colorbar(1,j),'Units',old_cunits);
      %
      old_aunits = get(curr_axes,'Units');
      set(curr_axes,'Units','pixels');
      curr_axes_pos = get(curr_axes,'Position');
      %
      kids = get(this_colorbar(1,j),'Children')';
      set(this_colorbar(1,j),'Visible','off');
      set(kids,'Visible','off');
      set(kids(1,1),'UserData','deleted');
      if isfield(toolbar,'colorbar')==1
         delete(toolbar.colorbar);
         toolbar = rmfield(toolbar,'colorbar');
      end;
      set(toolbar.deletecolorbar,'Label','&Add Colorbar','Callback','add_colorbar_fcn');
      new_axes_pos = [curr_axes_pos(1:2) colorbar_pos(1)+colorbar_pos(3)-curr_axes_pos(1) curr_axes_pos(4)];
      set(curr_axes,'Position',new_axes_pos);
      %
      % update the legend
      %
      old_leg = get(curr_axes,'UserData');
      if isempty(old_leg)==0;
         if ishandle(old_leg)==0;
            old_leg = find_legend(curr_axes);
         end;
         ud = get(old_leg,'UserData');
         leg_context = get(ud.UIContextMenu);
         lock_handle = findobj(leg_context,'Label','Unlock Legend')';
         if isempty(lock_handle)==1;
            if (ud.legendpos==1)|(ud.legendpos==4);
               old_leg_units = get(old_leg,'Units');
               set(old_leg,'Units','pixels');
               plot_pos = get(old_leg,'Position');
               set(old_leg,'Position',[max(new_axes_pos(1)+new_axes_pos(3)-(curr_axes_pos(1)+curr_axes_pos(3)-plot_pos(1)),0) plot_pos(2:4)]);
               set(old_leg,'Units',old_leg_units);
               leg_pos = get(old_leg,'Position');
               ud.LegendPosition = leg_pos;
               set(old_leg,'UserData',ud);
            end;
         end;
      end;
      set(curr_axes,'Units',old_aunits);
      set(h,'UserData',toolbar);
      %
      % fix context menu of axes
      %
      create_axes_contextmenu_fcn(curr_axes);
   end;

end;

%
% end of delete_colorbar_fcn.m
%
