function delete_line_patch_fcn

old_leg = get(gca,'UserData');
tag_str = get(gco,'Tag');

if isempty(old_leg)==0;
   leg_ud = get(old_leg,'UserData');
   old_strings = leg_ud.lstrings;
   %
   % determine which line to delete (in terms of handle order in current axes)
   % and update the strings in the legend. Note lines and patches which cannot
   % by construction appear in a legend needs to be removed from the list of
   % handles since they won't have a text string in the legend
   %
   this_line = sort(findobj(get(gca,'Children')','Type','line')');
   if isempty(this_line)==0;
      fixhandles = [];
      for j=1:size(this_line,2);
         checkvec = get(this_line(1,j),'YData');
         checkvec2 = sum(get(this_line(1,j),'XData'));
         checkstyle = get(this_line(1,j),'LineStyle');
         checktag = get(this_line(1,j),'Tag');
         if size(checktag,2)>8;
            checktag = checktag(1,1:8);
         end;
         if ((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(this_line(1,j),'UserData'))==0))|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'light')==1)|(strcmp(checktag,'3dlines-')==1)|(strcmp(checktag,'2dlines-')==1);
            fixhandles = [fixhandles 0];
         else;
            fixhandles = [fixhandles 1];
         end;
      end;
      this_line = this_line(fixhandles==1);
   end;
   this_patch = sort(findobj(get(gca,'Children')','Type','patch')');
   if isempty(this_patch)==0;
      fixhandles = [];
      for j=1:size(this_patch,2);
         checktag = get(this_patch(1,j),'Tag');
         if size(checktag,2)>9;
            checktag = checktag(1,1:9);
         end;
         if (strcmp(checktag,'varpatch-')==1)|(strcmp(checktag,'rectpatch')==1);
            fixhandles = [fixhandles 0];
         else;
            fixhandles = [fixhandles 1];
         end;
      end;
      this_patch = this_patch(fixhandles==1);
   end;
   curr_objects = sort([this_line this_patch]);
   %
   % best guess is last text string
   %
   if strcmp(get(gco,'Tag'),'rectpatch')==0;
      del_line_num = size(old_strings,2);
      legObj = leg_ud.handles;
      for i=1:max(size(legObj));
         if gco==legObj(i);
            del_line_num = i;
            break;
         end;
      end;
   else;
      del_line_num = 0;
   end;
   my_strings = '';
   for i=1:size(old_strings,2);
      if (i<del_line_num)|(i>del_line_num);
         my_strings = strvcat(my_strings,old_strings{i});
      end;
   end;
   delete(gco);
   %
   % update legend if there are still strings
   %
   if isempty(my_strings)==0;
      old_leg_color = get(old_leg,'Color');
      %
      % check object order in legend and its position
      % (info needed for add_legend_fcn
      %
      if size(leg_ud.handles,1)>1;
         leg_ud.handles = leg_ud.handles';
      end;
      new_handles = zeros(1,size(leg_ud.handles,2)-1);
      num = 0;
      for i=1:size(leg_ud.handles,2);
         if i~=del_line_num;
            num = num+1;
            new_handles(1,num) = leg_ud.handles(1,i);
         end;
      end;
      [sort_h,h_ind] = sort(new_handles);
      leg_pos = leg_ud.legendpos;
      %
      if strcmp(tag_str,'rectpatch')==0;
         delete_legend(old_leg);
         new_leg = add_legend_fcn(my_strings,h_ind,leg_pos);
         if ishandle(new_leg)==1;
            set(new_leg,'Color',old_leg_color);
         end;
      end;
   else;
      if strcmp(tag_str,'rectpatch')==0;
         delete_legend_fcn;
      end;
      %
      % check if we should set the axes back to base values
      % including removing any zero lines
      %
      my_lines = sort(findobj(gca,'Type','line')');
      my_patches = sort(findobj(gca,'Type','patch')');
      if isempty([my_lines my_patches])==0;
         if isempty(my_patches)==1;
            for j=1:size(my_lines,2);
               del_lines = 0;
               if isempty(get(my_lines(1,j),'UIContextMenu'))==1;
                  del_lines = del_lines+1;
                  delete(my_lines(1,j));
               end;
            end;
         else;
            del_lines = -1;
         end;
         if del_lines==size(my_lines,2);
            set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
            create_axes_contextmenu_fcn(gca);
         end;
      else;
         set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
         create_axes_contextmenu_fcn(gca);
      end;
   end;
else;
   if strcmp(tag_str,'rectpatch')==0;
      delete(gco);
      %
      % check if we should set the axes back to base values
      % including removing any zero lines
      %
      my_lines = sort(findobj(gca,'Type','line')');
      my_patches = sort(findobj(gca,'Type','patch')');
      if isempty([my_lines my_patches])==0;
         if isempty(my_patches)==1;
            del_lines_handles = [];
            for j=1:size(my_lines,2);
               del_lines = 0;
               if isempty(get(my_lines(1,j),'UIContextMenu'))==1;
                  del_lines = del_lines+1;
                  del_lines_handles = [del_lines_handles my_lines(1,j)];
               end;
            end;
            if size(del_lines_handles,2)==size(my_lines,2);
               delete(del_lines_handles);
            end;
         else;
            del_lines = -1;
         end;
         if del_lines==size(my_lines,2);
            set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
            create_axes_contextmenu_fcn(gca);
         end;
      else;
         set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
         create_axes_contextmenu_fcn(gca);
      end;
   else;
      delete(gco);
      if isempty(get(gca,'Children'))==1;
         set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
         create_axes_contextmenu_fcn(gca);
      else;
         %
         % check if there are only non-data related lines
         %
         my_patches = sort(findobj(get(gca,'Children')','Type','patch')');
         if isempty(my_patches)==1;
            this_line = sort(findobj(get(gca,'Children')','Type','line')');
            if isempty(this_line)==0;
               del_handles = 0;
               for j=1:size(this_line,2);
                  checkvec = get(this_line(1,j),'YData');
                  checkvec2 = sum(get(this_line(1,j),'XData'));
                  checkstyle = get(this_line(1,j),'LineStyle');
                  checktag = get(this_line(1,j),'Tag');
                  if size(checktag,2)>8;
                     checktag = checktag(1,1:8);
                  end;
                  if ((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(this_line(1,j),'UserData'))==0))|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'light')==1)|(strcmp(checktag,'3dlines-')==1)|(strcmp(checktag,'2dlines-')==1);
                     del_handles = del_handles+1;
                  end;
               end;
               if del_handles==size(this_line,2);
                  delete(this_line);
                  set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
                  create_axes_contextmenu_fcn(gca);
               end;
            else;
               set(gca,'XLim',[0 1],'YLim',[0 1],'ZLim',[0 1],'View',[0 90]);
               create_axes_contextmenu_fcn(gca);
            end;
         end;
      end;
   end;
end;

%
% check remaining lines and patches
%

this_line = sort(findobj(get(gca,'Children')','Type','line')');
this_patch = sort(findobj(get(gca,'Children')','Type','patch')');
curr_objects = sort([this_line this_patch]);
if isempty(curr_objects)==0;
   txt = 'Would you like to fix the limits on the vertical axis to fit the remaining lines and bars (patches)?';
   answer = query(txt,'question',120,'Fix Vertical Axis',350,'no');
   if strcmp(answer,'Yes')==1;
      max_y = [];
      min_y = [];
      for i=1:size(curr_objects,2);
         max_y = max([max_y max(max(get(curr_objects(1,i),'YData')))]);
         min_y = min([min_y min(min(get(curr_objects(1,i),'YData')))]);
      end;
      scale_y = (abs(max_y)+abs(min_y))/10;
      set(gca,'YLim',[min_y-scale_y max_y+scale_y]);
   end;
end;

%
% end of delete_line_patch_fcn.m
%
