function [delta,stat] = delta_rank_rnd(Z0,Z1,Z2,D,r,n,d,Omega,Gamma,alpha,beta,D_mu,D_sigma,cu_symmetric)

Z = Z0;
if isempty(Gamma)==0;
   Z = Z-(Gamma*Z2);
end;
if r>0;
   Z = Z-(alpha*beta'*Z1);
end;
%
% compute the mean and covariance for delta conditional on
% alpha, beta, Gamma, Omega, and the data
%

if isempty(D_sigma)==1;
   cov_mat = D*D';
else;
   cov_mat = (D*D')+inverse(D_sigma);
end;
cov_mat = inverse(cov_mat);
mean_vec = vec(Z*D'*cov_mat);
cov_mat = kron(cov_mat,Omega);

[std_mat,stat] = chol(cov_mat);
if stat>0;
   delta = [];
   return;
end;
%
if cu_symmetric==1;
   std_mat = symm(cov_mat);
end;

delta_vec = mean_vec+(std_mat'*randn(n*d,1));
delta = vecinv(delta_vec,n);

%
% end of delta_rank_rnd.m
%
