%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab function for creating the duplication          %
%          matrix for vectorizations of an mxm symmetric         %
%          matrix                                                %
%                                                                %
%          Function: duplication                                 %
%                                                                %
%          Input:                                                %
%                        m: integer                              %
%                                                                %
%          Output:                                               %
%          		 Dm: m^2xm(m+1)/2 0-1 matrix             %
%          		     for duplicating vech function       %
%                            of a symmetric matrix into          %
%                            the vec function                    %
%                                                                %
%          This version:        January 29, 2002                 %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2002          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function Dm = duplication(m)

Dm = zeros(m*m,m*(m+1)/2);
dmel2 = 0;
j = 1;
while j <= m;
   i = 1;
   while i <= m-j+1;
      dmel2 = dmel2+1;
      Dm(i+(m+1)*(j-1),dmel2) = 1;
      i = i+1;
   end;
   j = j+1;
end;
if m > 1;
   j = 1;
   while j <= m-1;
      dmstar = 1;
      i = 1;
      while i <= j;
         Dm(i+m*j,dmstar+j-i+1) = 1;
         dmstar = dmstar+m-i+1;
         i = i+1;
      end;
      j = j+1;
   end;
end;

%
% End of function duplication
%
