function [dtstr,mystrout] = getdatestr(mystr)

%
% Function to extract dates from a file using e.g. the formats
%    1980:4  1980(4)   1980#4   1980Q4   1980M2
%    1980q1  1980m4 1980[4] 1980{4} 1980@4
%    1980Y 1980y
%
% NOTES: Function does NOT accept 1980 as a date
%
%        In addition, dates must appear in the first "column"
%        of mystr, since the function always checks against the
%        first non-whitespace entry in a string.
%

status = 0;
dtstr = '';
thisstr = '';
mystrout = '';

check = sscanf(mystr(1,:),'%s:%s');
if strcmp(check,'')==0;
   if isempty(mystr2num(check))==1;
      status = 1;
   end;
end;

if status==1;
   k = size(mystr,1);
   for i=1:k;
      dtstri = sscanf(mystr(i,:),'%s:%s');
      mystrouti = strrep(mystr(i,:),dtstri,'');
      dtstri = strrep(dtstri,':',' ');
      dtstr = strvcat(dtstr,dtstri);
      mystrout = strvcat(mystrout,mystrouti);
   end;
end;

if ((size(mystr2num(dtstr),2)==~2)&(size(mystr2num(dtstr),2)==~1));
   dtstr = '';
   mystrout = mystr;
%elseif size(mystr2num(dtstr),2)==2;
%   check = sum(mystr2num(dtstr));
%   if check(1,2)>check(1,1);
%      check = mystr2num(dtstr);
%      dtstr = '';
%      for i=1:size(check,1);
%         dtstr = strvcat(dtstr,([num2str(check(i,2),'%1.0f') ' ' num2str(check(i,1),'%1.0f')]));
%      end;
%   end;
elseif size(mystr2num(dtstr),2)==1;
   add_str = '';
   for i=1:size(dtstr,1);
      add_str = strvcat(add_str,' 1');
   end;
   dtstr = [dtstr add_str];
end;

%
% end of getdatestr.m
%
