function [out,bin] = histc(in,bins,dice)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% NOTES:
%
% A real histc.m function rather than the mex-function in matlab.
% somewhat more limited since "dice" is not taken into account,
% but this variable is not needed here. we also remove -inf from the
% beginning of the bins vector. bin out is always empty but
% included to avoid warnings when compiling
%
% Written by:          Anders Warne
%                      Copyright (c) 2001-2002
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% preliminaries
%

[n1 T1] = size(in);
if n1<T1;
   in = in';
   [n1 T1] = size(in);
end;
in = sort(in(:,1));
bins = bins(1,2:size(bins,2));
k = size(bins,2);

%
% counting the number of elements in in that occur for each interval
% determined by bins
%

out = 0;
for j=1:k;
   mybin = bins(1,j);
   this = sum(in<=mybin*ones(n1,1));
   out = [out;this];
end;

out = diff(out);

if n1>sum(out);
   out = [out;(n1-sum(out))];
end;

if size(out,1)<=k;
   out = [out;zeros(k+1-size(out,1),1)];
end;

if nargout==2;
   bin = [];
end;

%
% end of histc.m
%
