function lpr_omega = logprior_rank_omega(Omega,A,q,alpha,beta,r,lambda_alpha)

%
% evaluates the log of prior density for Omega
%
n = size(Omega,1);

log_cr = ((q/2)*log(det(A))) - (((n*q)/2)*log(2)) - (((n*(n-1))/4)*log(pi)) - (((r*(n-r))/2)*log(pi)) - (((n*r)/2)*log(2*pi*(lambda_alpha^2))) - gamma_product(n,q);
if r>0;
   log_cr = log_cr - gamma_product(r,n) - gamma_product(r,r);
end;

%
% Here we use p(Omega|alpha,beta) is proportional to p(Omega,alpha,beta)
%

lpr_omega = log_cr - (((n+q+1+r)/2)*log(det(Omega))) - ((1/2)*sum(diag(inverse(Omega)*(A+ ((1/(lambda_alpha^2))*alpha*beta'*beta*alpha')  ))));

%
% end of logprior_rank_omega.m
%
