function [out,m_v,curr_ini] = main_model_select_fcn(out,m_v,curr_ini,fig)

m_v.newp = get(out.mypopup,'Value');
p_str = get(out.mypopup,'String');
m_v.maxp = size(p_str,1);
m_v.newh = get(out.mypopuph,'Value');
m_v.newc = get(out.mypopupc,'Value');
m_v.modelfile = get(out.open,'UserData');
m_v.spectest(1,1) = get(out.serial,'Value');
m_v.spectest(1,2) = get(out.arch,'Value');
m_v.spectest(1,3) = get(out.normality,'Value');
m_v.spectest(1,4) = get(out.constancy,'Value');
%
m_v.modelfile = getname(m_v.modelfile);
m_v.cointvalue = get(out.radiocoint,'Value');
m_v.nocointvalue = get(out.radionocoint,'Value');
m_v.endofile = get(out.endogenous,'String');
m_v.modelsdir = get(out.endogenous,'UserData');
if strcmp(m_v.modelsdir,'')==1;
   if curr_ini.dirstructure==0;
      m_v.modelsdir = getpath(m_v.outputfile);
      mysize = size(m_v.modelsdir,2);
      mymodelsdir1 = m_v.modelsdir(1,1:mysize-8);
      mymodelsdir2 = m_v.modelsdir(1,mysize);
      m_v.modelsdir = [mymodelsdir1 'models' mymodelsdir2];
   else;
      m_v.modelsdir = getpath(m_v.endofile);
   end;
end;
m_v.exo1file = get(out.exogenous1,'String');
m_v.exo0file = get(out.exogenous0,'String');
m_v.deterfile = get(out.deterministic,'String');
m_v.evars = get(out.endonames,'UserData');
m_v.xvars1 = get(out.exo1names,'UserData');
m_v.xvars0 = get(out.exo0names,'UserData');
m_v.deter = get(out.deternames,'UserData');
m_v.outputfile = get(out.outputfile,'String');
numout = size(m_v.outputfile,2);
if numout<=4;
   if (isfield(m_v,'outputdir')==0)|(direxist(m_v.outputdir)==0);
      mypwd = pwd;
      if strcmp(mypwd(1,1),'/')==1;
         if curr_ini.dirstructure==1;
            m_v.outputfile = strcat(pwd,'/output.txt');
         else;
            m_v.outputfile = strcat(pwd,'/results/output.txt');
         end;
      else;
         if curr_ini.dirstructure==1;
            m_v.outputfile = strcat(pwd,'\output.txt');
         else;
            m_v.outputfile = strcat(pwd,'\results\output.txt');
         end;
      end;
   else;
      m_v.outputfile = [m_v.outputdir 'output-' getname(m_v.endofile) '.txt'];
   end;
   set(out.outputfile,'String',m_v.outputfile);
end;
numout = size(m_v.exo1file,2);
if numout>0;
   if fileexist(m_v.exo1file)==0;
      m_v.exo1file = '';
      m_v.xvars1 = '';
   end;
end;
numout = size(m_v.exo0file,2);
if numout>0;
   if fileexist(m_v.exo0file)==0;
      m_v.exo0file = '';
      m_v.xvars0 = '';
   end;
end;
numout = size(m_v.deterfile,2);
if numout>0;
   if fileexist(m_v.deterfile)==0;
      m_v.deterfile = '';
      m_v.deter = '';
   end;
end;
m_v.p = m_v.newp;
m_v.h = m_v.newh;
m_v.c = 49+m_v.newc;



set(out.statusbar,'String',['Running model selection routine for "' getname(m_v.inputfile) '"...']);
set(fig,'WindowButtonMotionFcn','');
outputdir = getpath(m_v.outputfile);
%
% check if output-file exist
%
if direxist(outputdir)==0;
   mystatus = makedirs(outputdir);
end;
%
m_v.deterselect(1,1) = get(out.uconstant,'Value');
m_v.deterselect(1,2) = get(out.rconstant,'Value');
m_v.deterselect(1,3) = get(out.utrend,'Value');
m_v.deterselect(1,4) = get(out.rtrend,'Value');
m_v.modeltype(1,1) = get(out.structural,'Value');
m_v.modeltype(1,2) = get(out.reduced,'Value');
m_v.seasonal(1,1) = get(out.seasonal,'Value');
m_v.seasonal(1,2) = get(out.noseasonal,'Value');
m_v.beginyear = get(out.beginyear,'String');
m_v.beginyear = strrep(m_v.beginyear,' ','');
m_v.beginperiod = get(out.beginperiod,'String');
m_v.beginperiod = strrep(m_v.beginperiod,' ','');
m_v.endyear = get(out.endyear,'String');
m_v.endyear = strrep(m_v.endyear,' ','');
m_v.endperiod = get(out.endperiod,'String');
m_v.endperiod = strrep(m_v.endperiod,' ','');
m_v.subbeginyear = get(out.subbeginyear,'String');
m_v.subbeginyear = strrep(m_v.subbeginyear,' ','');
m_v.subbeginperiod = get(out.subbeginperiod,'String');
m_v.subbeginperiod = strrep(m_v.subbeginperiod,' ','');
m_v.subendyear = get(out.subendyear,'String');
m_v.subendyear = strrep(m_v.subendyear,' ','');
m_v.subendperiod = get(out.subendperiod,'String');
m_v.subendperiod = strrep(m_v.subendperiod,' ','');
set(out.run,'Enable','off');
set(out.estimate,'Enable','off');
set(out.model_select,'Enable','off');
if (strcmp(get(out.endogenous,'Type'),'uicontrol')==1)&(isfield(out,'editundo')==1);
   set(out.editundo,'Enable','off');
   set(out.editcopy,'Enable','off');
   set(out.editcut,'Enable','off');
   set(out.editpaste,'Enable','off');
   set(out.editselectall,'Enable','off');
   set(out.cutbtn,'Enable','off');
   set(out.copybtn,'Enable','off');
   set(out.pastebtn,'Enable','off');
   set(out.selectallbtn,'Enable','off');
end;
newxvars1 = m_v.xvars1;
newxvars0 = m_v.xvars0;

%
% the model selection function
%

model_select(m_v,curr_ini,fig);


ud = get(out.statusbar,'UserData');
set(out.statusbar,'String',ud.string);
set(fig,'WindowButtonMotionFcn','show_main_status_fcn');
m_v.xvars1 = newxvars1;
m_v.xvars0 = newxvars0;
set(out.run,'Enable','on');
set(out.estimate,'Enable','on');
set(out.model_select,'Enable','on');
if (strcmp(get(out.endogenous,'Type'),'uicontrol')==1)&(isfield(out,'editundo')==1);
   set(out.editundo,'Enable','on');
   set(out.editcopy,'Enable','on');
   set(out.editcut,'Enable','on');
   set(out.editpaste,'Enable','on');
   set(out.editselectall,'Enable','on');
   set(out.cutbtn,'Enable','on');
   set(out.copybtn,'Enable','on');
   set(out.pastebtn,'Enable','on');
   set(out.selectallbtn,'Enable','on');
end;

%
% end of main_model_select_fcn.m
%
