function move_light_fcn(in)

this_fig = findobj('Type','figure','Tag','StructuralVAR');
model = get(this_fig,'UserData');

if nargin==0;
   in = 0;
   moved_light = 0;
else;
   moved_light = get(model.filemenu,'UserData');
end;

light_line = findobj(gca,'Type','line','UserData','light')';
if light_line==gco;
   h = get(0,'CurrentFigure');
   toolbar = get(h,'UserData');
   if in==0;
      if strcmp(get(h,'SelectionType'),'normal')==1;
         %
         % preparing the move of the light object
         %
         set(h,'Pointer','fleur','DoubleBuffer','on');
         if isfield(toolbar,'lineentry')==0;
            toolbar.lineentry = uicontrol('Parent',h, ...
               'Units','pixels', ...
               'Position',[2 2 200 15], ...
               'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
               'Visible','off', ...
               'Style','text', ...
               'ForegroundColor',[0.8 0 0], ...
               'HorizontalAlignment','left', ...
               'String','');
            set(h,'UserData',toolbar);
         end;
         set(h,'WindowButtonMotionFcn','move_light_fcn(1)','WindowButtonUpFcn','move_light_fcn(2)');
         light_line = findobj(gca,'Type','line','UserData','light')';
         set(light_line,'EraseMode','xor');
         ax_cp = get(gca,'CurrentPoint');
         ax_cp = ax_cp(1,:);
         set(toolbar.lineentry,'Visible','on','String',['X: ' num2str(ax_cp(1),'%0.4f') '   Y: ' num2str(ax_cp(2),'%0.4f') '   Z: ' num2str(ax_cp(3),'%0.4f')]);
         set(model.filemenu,'UserData',moved_light);
      end;
   elseif in==1;
      %
      % moving the light object
      %
      ax_cp = get(gca,'CurrentPoint');
      ax_cp = ax_cp(1,:);
      ax_xlim = get(gca,'XLim');
      ax_ylim = get(gca,'YLim');
      ax_zlim = get(gca,'ZLim');
      if (ax_cp(1)>=ax_xlim(1)-1)&(ax_cp(1)<=ax_xlim(2)+1)&(ax_cp(2)>=ax_ylim(1)-1)&(ax_cp(2)<=ax_ylim(2)+1)&(ax_cp(3)>=ax_zlim(1)-1)&(ax_cp(3)<=ax_zlim(2)+1);
         moved_light = 1;
         light_line = findobj(gca,'Type','line','UserData','light')';
         set(light_line,'XData',ax_cp(1),'YData',ax_cp(2),'ZData',ax_cp(3));
         my_light = findobj(gca,'Type','light')';
         set(my_light,'Position',ax_cp);
         set(toolbar.lineentry,'Visible','on','String',['X: ' num2str(ax_cp(1),'%0.4f') '   Y: ' num2str(ax_cp(2),'%0.4f') '   Z: ' num2str(ax_cp(3),'%0.4f')]);
      else;
         set(toolbar.lineentry,'Visible','off');
      end;
      set(model.filemenu,'UserData',moved_light);
   elseif in==2;
      %
      % returning to normal
      %
      set(h,'Pointer','arrow','WindowButtonMotionFcn','','WindowButtonUpFcn','','DoubleBuffer','off');
      set(toolbar.lineentry,'Visible','off','String','');
      light_line = findobj(gca,'Type','line','UserData','light')';
      set(light_line,'EraseMode','normal');
      if moved_light==1;
         %
         % fix context menu of axes
         %
         axes_context_menu = get(gca,'UIContextMenu');
         light_pos_parent = findobj(axes_context_menu,'Label','Light Position')';
         kids = sort(get(light_pos_parent,'Children')');
         for i=1:size(kids,2);
            set(kids(1,i),'Checked','off');
         end;
      end;
      set(model.filemenu,'UserData',[]);
   end;
end;

%
% end of move_light_fcn.m
%
