function movie_3d_fcn(selector)

if nargin==0;
   selector = 'init';
else;
   if ishandle(selector)==1;
      h = selector;
      ud = get(h,'UserData');
      selector = 'init';
   else;
      h = get(0,'CurrentFigure');
      ud = get(h,'UserData');
   end;
end;

switch selector
   case 'init'
      %
      % play a movie
      %
      ud.run = 0;
      pos = [];
      play_enable = 'off';
      if nargin==0;
         h = get(0,'CurrentFigure');
         toolbar = get(h,'UserData');
         if isempty(get(toolbar.movie,'UserData'))==0;
            movie_file = get(toolbar.movie,'UserData');
            if ischar(movie_file)==1;
               if fileexist(movie_file)==1;
                  %
                  % we have a valid file
                  %
                  txt = strvcat(' ','Attempting to load movie...',' ','Please hold!');
                  mywait = waitdlg(txt,'movie');
                  waitf = get(mywait,'UserData');
                  drawnow;
                  newfile = load(movie_file);
                  set(waitf.text,'UserData','done');
                  delete(mywait);
                  drawnow;
                  if isfield(newfile,'m')==1;
                     play_enable = 'on';
                     m = newfile.m;
                     if isfield(newfile,'movie_color')==1;
                        fig_color = newfile.movie_color;
                     else;
                        fig_color = [1 1 1];
                     end;
                     if isfield(newfile,'movie_pos')==1;
                        pos = newfile.movie_pos;
                     else;
                        w_h = size(newfile.m(1).cdata(:,:,1));
                        realscrsz = get(0,'ScreenSize');
                        pos = [(realscrsz(3:4)-[w_h(2) w_h(1)])/2 w_h(2) w_h(1)]+[-20 -20 40 40];
                     end;
                     if isfield(newfile,'movie_renderer')==1;
                        fig_renderer = newfile.movie_renderer;
                     else;
                        fig_renderer = 'zbuffer';
                     end;
                     if isfield(newfile,'movie_name')==1;
                        fig_name = newfile.movie_name;
                     else;
                        fig_name = getname(movie_file);
                     end;
                  end;
               end;
            end;
         end;
         %
         if isempty(pos)==1;
            m = [];
            old_units = get(h,'Units');
            set(h,'Units','pixels');
            pos = get(h,'Position')+[-20 -20 40 40];
            set(h,'Units',old_units);
            if pos(1)<0;
               pos(3) = pos(3)-pos(1);
               pos(1) = 0;
            end;
            if pos(2)<0;
               pos(4) = pos(4)-pos(2);
               pos(2) = 0;
            end;
            fig_color = get(h,'Color');
            fig_renderer = get(h,'Renderer');
            fig_name = get(h,'Name');
         end;
      else;
         play_enable = 'on';
         m = ud.m;
         pos = ud.pos;
         fig_color = ud.color;
         fig_renderer = ud.renderer;
         fig_name = ud.name;
         delete(h);
         drawnow;
      end;
      % open a TV to show movie
      %
      mycons = getstoredimages;
      curr_ini = find_inisettings;
      if curr_ini.use_toolbar_bgcolor==1;
         bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
         bgcolor(1) = max(0,bgcolor(1));
         bgcolor(2) = max(0,bgcolor(2));
         bgcolor(3) = max(0,bgcolor(3));
      else;
         bgcolor = [NaN NaN NaN];
      end;
      my_forward = maketrans(mycons.forward_image,[160 160 164],bgcolor);
      my_backward = maketrans(mycons.backward_image,[160 160 164],bgcolor);
      %
      new_fig = figure('Color',fig_color, ...
                    'Menubar','none', ...
                    'Units','pixels', ...
                    'Position',pos, ...
                    'Renderer',fig_renderer, ...
                    'NumberTitle','off', ...
                    'Resize','off', ...
                    'WindowStyle','normal', ...
                    'DoubleBuffer','on', ...
                    'CloseRequestFcn','movie_3d_fcn wayout', ...
                    'Name',['MoviePlayer - ' fig_name], ...
                    'Visible','off');
      %
      posi = pos;
      if pos(3)<150;
         posi(1) = pos(1)-((150-pos(3))/2);
         posi(3) = 150;
         set(new_fig,'Position',posi);
      end;
      if matlabnumber>=7.0;
         set(new_fig,'DockControl','off');
      end;
      ud.color = fig_color;
      ud.renderer = fig_renderer;
      ud.name = fig_name;
      %
      % Create a toolbar
      %
      btndata(1).cdata = curr_ini.images.open;
      btndata(1).userdata = [];
      btndata(2).cdata = curr_ini.images.save;
      btndata(2).userdata = [];
      btndata(3).cdata = my_forward;
      btndata(3).userdata = [];
      btndata(4).cdata = my_backward;
      btndata(4).userdata = [];
      btndata(5).cdata = curr_ini.images.close;
      btndata(5).userdata = [];
      %
      flds = cellstr(strvcat('toolbar','open','save','forward','backward','close'))';
      buttons.type = cellstr(strvcat('push','push','push','push','push'))';
      buttons.tooltipstr = cellstr(strvcat('Open Movie','Save Movie','Play','Play Backwards','Exit'))';
      buttons.callbackstr = cellstr(strvcat('movie_3d_fcn open','movie_3d_fcn save','movie_3d_fcn forward','movie_3d_fcn backward','movie_3d_fcn wayout'))';
      buttons.enablestr = cellstr(strvcat('on',play_enable,play_enable,play_enable,'on'))';
      buttons.separatorstr = cellstr(strvcat('off','off','on','off','on'))';
      buttons.statestr = cellstr(strvcat(' ',' ',' ',' ',' '))';
      buttons.tagstr = cellstr(strvcat('OpenMovieButton','SaveMovieButton','ForwardButton','BackwardButton','CloseButton'))';
      %
      ud.movietools = make_toolbar([],new_fig,flds,btndata,buttons);
      %
      % creating a black frame
      %
      ud.icon = axes('Parent',new_fig, ...
                     'Units','pixels', ...
                     'Tag','MovieAxesOuter1', ...
                     'Position',[0 0 posi(3) 19], ...
                     'Color',[0 0 0], ...
                     'Box','on', ...
                     'XLim',[0 1], ...
                     'ZLim',[0 1], ...
                     'TickLength',[0 0], ...
                     'XTickLabel',[], ...
                     'YTickLabel',[], ...
                     'Visible','on');
      %
      axes('Parent',new_fig, ...
               'Units','pixels', ...
               'Tag','MovieAxesOuter2', ...
               'Position',[0 0 19 pos(4)], ...
               'Color',[0 0 0], ...
               'Box','on', ...
               'XLim',[0 1], ...
               'ZLim',[0 1], ...
               'TickLength',[0 0], ...
               'XTickLabel',[], ...
               'YTickLabel',[], ...
               'Visible','on');
      %
      axes('Parent',new_fig, ...
               'Units','pixels', ...
               'Tag','MovieAxesOuter3', ...
               'Position',[pos(3)-19 0 19+(posi(3)-pos(3)) pos(4)], ...
               'Color',[0 0 0], ...
               'Box','on', ...
               'XLim',[0 1], ...
               'ZLim',[0 1], ...
               'TickLength',[0 0], ...
               'XTickLabel',[], ...
               'YTickLabel',[], ...
               'Visible','on');
      %
      axes('Parent',new_fig, ...
               'Units','pixels', ...
               'Tag','MovieAxesOuter4', ...
               'Position',[0 pos(4)-19 posi(3) 19], ...
               'Color',[0 0 0], ...
               'Box','on', ...
               'XLim',[0 1], ...
               'ZLim',[0 1], ...
               'TickLength',[0 0], ...
               'XTickLabel',[], ...
               'YTickLabel',[], ...
               'Visible','on');
      %
      ud.curr_ini = curr_ini;
      ud.pos = pos;
      ud.m = m;
      set(new_fig,'UserData',ud,'HandleVisibility','callback');
   case 'save'
      savedir = ud.curr_ini.model.modelsdir;
      [savefile,savepath] = uiputfile([savedir getname(ud.curr_ini.model.inputfile) '-new-movie.mat'],'Save As');
      drawnow;
      if isnumeric(savefile)==0;
         if strcmp(lower(getext(savefile)),'.mat')==1;
            m = ud.m;
            movie_color = ud.color;
            movie_pos = ud.pos;
            movie_renderer = ud.renderer;
            movie_name = ud.name;
            save(strcat(savepath,savefile),'m','movie_color','movie_pos','movie_renderer','movie_name');
         else;
            textstr = ['The file extension you selected, "' strrep(getext(savefile),'.','') '", is not supported for saving movies in Structural VAR. Please save movie files in MatLab MAT Files.'];
            about(textstr,'error','Bad Movie File Extension',120,350);
         end;
      end;
   case 'open'
      if matlabnumber>=6.0;
         inputfile = {'*.mat', 'MatLab MAT Files (*.mat)'};
      else;
         if (iscompiled==1)&(iswinnt==1)&(ud.curr_ini.opendialog==1);
            basedir = ud.curr_ini.model.modelsdir;
            file_fltr = 'MatLab MAT Files (*.mat)|*.mat|';
            best_pos = 1;
            title_txt = 'Open';
         else;
            inputfile = '*.mat';
         end;
      end;
      if (iscompiled==1)&(iswinnt==1)&(ud.curr_ini.opendialog==1)&(matlabnumber<6.0);
         [savefile,savepath] = fileopen(basedir,file_fltr,best_pos,title_txt);
      else;
         if matlabnumber>=6;
            [savefile,savepath] = uigetfile(inputfile,'Open',ud.curr_ini.model.modelsdir);
         else;
            [savefile,savepath] = uigetfile(strcat(ud.curr_ini.model.modelsdir,inputfile),'Open');
         end;
      end;
      drawnow;
      if isnumeric(savefile)==0;
         if strcmp(lower(getext(savefile)),'.mat')==1;
            set(h,'Visible','off');
            drawnow;
            txt = strvcat(' ','Attempting to load movie...',' ','Please hold!');
            mywait = waitdlg(txt,'movie');
            waitf = get(mywait,'UserData');
            drawnow;
            newfile = load(strcat(savepath,savefile));
            set(waitf.text,'UserData','done');
            delete(mywait);
            drawnow;
            if isfield(newfile,'m')==1;
               ud.m = newfile.m;
               if isfield(newfile,'movie_color')==1;
                  ud.color = newfile.movie_color;
               else;
                  ud.color = [1 1 1];
               end;
               if isfield(newfile,'movie_pos')==1;
                  ud.pos = newfile.movie_pos;
               else;
                  w_h = size(newfile.m(1).cdata(:,:,1));
                  realscrsz = get(0,'ScreenSize');
                  ud.pos = [(realscrsz(3:4)-[w_h(2) w_h(1)])/2 w_h(2) w_h(1)]+[-20 -20 40 40];
               end;
               if isfield(newfile,'movie_renderer')==1;
                  ud.renderer = newfile.movie_renderer;
               else;
                  ud.renderer = 'zbuffer';
               end;
               if isfield(newfile,'movie_name')==1;
                  ud.name = newfile.movie_name;
               else;
                  ud.name = getname(savefile);
               end;
               %
               % need to re-draw the whole GUI by calling movie_3d_fcn with 'init'
               %
               set(h,'UserData',ud);
               movie_3d_fcn(h);
            else;
               set(h,'Visible','on');
               drawnow;
               textstr = ['The file "' newfile '" is not a valid Structural VAR movie file.'];
               about(textstr,'information','Invalid Movie File...',120,350);
            end;
         else;
            textstr = ['The file extension you selected, "' strrep(getext(savefile),'.','') '", is not supported for saving movies in Structural VAR. Please save movie files in MatLab MAT Files.'];
            about(textstr,'error','Bad Movie File Extension',120,350);
         end;
      end;
   case 'backward'
      if ud.run==0;
         ud.run = 1;
         movie(h,ud.m,[0 (size(ud.m,2):-1:1)],24,[19 19 1 1]);
         ud.run = 0;
      end;
   case 'forward'
      if ud.run==0;
         ud.run = 1;
         movie(h,ud.m,0,24,[19 19 1 1]);
         ud.run = 0;
      end;
   case 'wayout'
      if ud.run==0;
         killguipid(h);
      end;
end;

if strcmp(selector,'init')==1;
   if (iswinnt==1)&(iscompiled==1)&(curr_ini.loadguiicon==1);
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(new_fig,'Name') ' ' fix_filepath([pwd '\icons\movieplay.ico'])];
      dos(prog);
      if (strcmp(curr_ini.pstoolsdir,'')==0)&(appexist([curr_ini.pstoolsdir 'pslist.exe'])==1);
         %
         % now we need to determine the pid
         %
         pid = getpid('seticon');
         set(ud.icon,'UserData',pid);
      end;
   end;
   set(new_fig,'Visible','on');
   drawnow;
elseif (strcmp(selector,'open')==0)&(strcmp(selector,'wayout')==0);
   set(h,'UserData',ud);
end;
%
% end of movie_3d_fcn.m
%
