function [out,stat] = mystr2num(in)

%
% new "str2num" function to avoid eval statements
%
% stat 0 is OK
%     -1 is empty
%     -2 is missing observations

if nargout==2;
   stat = 0;
end;

if isempty(in);
   out = [];
   if nargout==2;
      stat = -1;
   end;
   return;
end;


out = [];

[m,n] = size(in);
thisout = cellstr(vecstr(in(1,:)))';
out = str2double(thisout);
out = out(isnan(out)==0);
for i=2:m;
   thisout = cellstr(vecstr(in(i,:)))';
   outi = str2double(thisout);
   if size(out,2)==size(outi(isnan(outi)==0),2);
      out = [out;outi(isnan(outi)==0)];
   else;
      out = [];
      if nargout==2;
         stat = -2;
      end;
      break;
   end;
end;

%
% end of mystr2num.m
%
