function new_figure_fcn(r,c)

if nargin==0;
   r = 1;
   c = 1;
elseif nargin==1;
   c = 1;
end;

curr_ini = find_inisettings;

%
% set paper orientation and figure colors
%

if curr_ini.landscape==1;
   orientstr = 'landscape';
else;
   orientstr = 'portrait';
end;

if curr_ini.invert_hardcopy==1;
   inv_hardcopy = 'on';
else;
   inv_hardcopy = 'off';
end;

if curr_ini.z_buffer==1;
   renderer = 'zbuffer';
else;
   renderer = 'painters';
end;
%
% position the new figure
%

realscrsz = get(0,'ScreenSize');
figpos = get(gcf,'Position');
newpos = [figpos(1)+22 figpos(2)+figpos(4)-406 512 384];
if ((figpos(1)+534)>realscrsz(3))|(figpos(2)<22);
   newpos(1) = 0;
   newpos(2) = realscrsz(4)-384;
end;

if strcmp(get(gcf,'Tag'),'StructuralVAR')==1;
   newpos = [(realscrsz(3:4)-newpos(3:4))/2 newpos(3:4)];
   drawnow;
end;

newfig = figure('Units','pixels', ...
   'Position',newpos, ...
   'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Renderer',renderer, ...
   'Menubar','none', ...
   'Toolbar','none', ...
   'NumberTitle','off', ...
   'Visible','off', ...
   'Tag','NewFigureFromStructuralVAR', ...
   'PaperUnits',curr_ini.paperunits, ...
   'PaperOrientation',orientstr, ...
   'PaperPositionMode',curr_ini.paperposmode, ...
   'PaperType',curr_ini.papertype, ...
   'InvertHardcopy',inv_hardcopy, ...
   'Name','New Figure');
%
if matlabnumber>=7.0;
   set(newfig,'DockControl','off');
end;
%
% obey centering and filling defaults
%
center_fill_figure(newfig,curr_ini.fill_value,curr_ini.center_value);
%

if iscompiled==1;
   set(newfig,'Menubar','none','Toolbar','none');
end;

if curr_ini.box==1;
   boxstr = 'on';
else;
   boxstr = 'off';
end;
if curr_ini.xgrid==1;
   xgridstr = 'on';
else;
   xgridstr = 'off';
end;
if curr_ini.ygrid==1;
   ygridstr = 'on';
else;
   ygridstr = 'off';
end;
if curr_ini.zgrid==1;
   zgridstr = 'on';
else;
   zgridstr = 'off';
end;

if r*c==1;
   new_axes = axes('Units','normalized', ...
      'Position',[0.1300 0.1100 0.7750 0.8150], ...
      'Box',boxstr, ...
      'XGrid',xgridstr, ...
      'YGrid',ygridstr, ...
      'ZGrid',zgridstr, ...
      'XLim',[0 1], ...
      'YLim',[0 1], ...
      'ZLim',[0 1], ...
      'FontAngle',curr_ini.axes_fontangle, ...
      'FontName',curr_ini.axes_fontname, ...
      'FontSize',curr_ini.axes_fontsize, ...
      'FontUnits',curr_ini.axes_fontunits, ...
      'FontWeight',curr_ini.axes_fontweight, ...
      'Color',[1 1 1], ...
      'XColor',curr_ini.axes_color, ...
      'YColor',curr_ini.axes_color, ...
      'ZColor',curr_ini.axes_color);
   %
   % setting up the title
   %
   new_title = title(' ', ...
      'Color',curr_ini.title_color, ...
      'FontAngle',curr_ini.title_fontangle, ...
      'FontName',curr_ini.title_fontname, ...
      'FontSize',curr_ini.title_fontsize, ...
      'FontUnits',curr_ini.title_fontunits, ...
      'FontWeight',curr_ini.title_fontweight);
   %
   % setting up the xlabel, ylabel, zlabel
   %
   new_xlabel = xlabel(' ', ...
      'Color',curr_ini.label_color, ...
      'FontAngle',curr_ini.label_fontangle, ...
      'FontName',curr_ini.label_fontname, ...
      'FontSize',curr_ini.label_fontsize, ...
      'FontUnits',curr_ini.label_fontunits, ...
      'FontWeight',curr_ini.label_fontweight);
   new_ylabel = ylabel(' ', ...
      'Color',curr_ini.label_color, ...
      'FontAngle',curr_ini.label_fontangle, ...
      'FontName',curr_ini.label_fontname, ...
      'FontSize',curr_ini.label_fontsize, ...
      'FontUnits',curr_ini.label_fontunits, ...
      'FontWeight',curr_ini.label_fontweight);
   new_zlabel = zlabel(' ', ...
      'Color',curr_ini.label_color, ...
      'FontAngle',curr_ini.label_fontangle, ...
      'FontName',curr_ini.label_fontname, ...
      'FontSize',curr_ini.label_fontsize, ...
      'FontUnits',curr_ini.label_fontunits, ...
      'FontWeight',curr_ini.label_fontweight);
else;
   new_axes = [];
   for i=1:r*c;
      h = subplot(r,c,i);
      set(h,'Units','normalized', ...
         'Box',boxstr, ...
         'XGrid',xgridstr, ...
         'YGrid',ygridstr, ...
         'ZGrid',zgridstr, ...
         'XLim',[0 1], ...
         'YLim',[0 1], ...
         'ZLim',[0 1], ...
         'FontAngle',curr_ini.axes_fontangle, ...
         'FontName',curr_ini.axes_fontname, ...
         'FontSize',curr_ini.axes_fontsize, ...
         'FontUnits',curr_ini.axes_fontunits, ...
         'FontWeight',curr_ini.axes_fontweight, ...
         'Color',[1 1 1], ...
         'XColor',curr_ini.axes_color, ...
         'YColor',curr_ini.axes_color, ...
         'ZColor',curr_ini.axes_color);
      %
      % setting up the title
      %
      new_title = title(' ', ...
         'Color',curr_ini.title_color, ...
         'FontAngle',curr_ini.title_fontangle, ...
         'FontName',curr_ini.title_fontname, ...
         'FontSize',curr_ini.title_fontsize, ...
         'FontUnits',curr_ini.title_fontunits, ...
         'FontWeight',curr_ini.title_fontweight);
      %
      % setting up the xlabel, ylabel, zlabel
      %
      new_xlabel = xlabel(' ', ...
         'Color',curr_ini.label_color, ...
         'FontAngle',curr_ini.label_fontangle, ...
         'FontName',curr_ini.label_fontname, ...
         'FontSize',curr_ini.label_fontsize, ...
         'FontUnits',curr_ini.label_fontunits, ...
         'FontWeight',curr_ini.label_fontweight);
      new_ylabel = ylabel(' ', ...
         'Color',curr_ini.label_color, ...
         'FontAngle',curr_ini.label_fontangle, ...
         'FontName',curr_ini.label_fontname, ...
         'FontSize',curr_ini.label_fontsize, ...
         'FontUnits',curr_ini.label_fontunits, ...
         'FontWeight',curr_ini.label_fontweight);
      new_zlabel = zlabel(' ', ...
         'Color',curr_ini.label_color, ...
         'FontAngle',curr_ini.label_fontangle, ...
         'FontName',curr_ini.label_fontname, ...
         'FontSize',curr_ini.label_fontsize, ...
         'FontUnits',curr_ini.label_fontunits, ...
         'FontWeight',curr_ini.label_fontweight);
      new_axes = [new_axes h];
   end;
end;
toolbar_fcn(new_axes);

set(newfig,'Visible','on');

%
% end of new_figure_fcn.m
%
