function nudge_fcn(type_var)

%
% type_var is either u (up), d (down), l (left), or r (right)
%

y_tick = get(gca,'YTick');
if size(y_tick,2)>1;
   nudge_val = (1/10)*(y_tick(1,2)-y_tick(1,1));
else;
   y_lim = get(gca,'YLim');
   nudge_val = (1/100)*y_lim(1,2)-y_lim(1,1);
end;
x_tick = get(gca,'XTick');
if size(x_tick,2)>1;
   nudge_val_x = (1/40)*(x_tick(1,2)-x_tick(1,1));
else;
   x_lim = get(gca,'XLim');
   nudge_val_x = (1/400)*x_lim(1,2)-x_lim(1,1);
end;

y_data = get(gco,'YData');
x_data = get(gco,'XData');
if strcmp(type_var,'u')==1;
   %
   % move up
   %
   y_data = y_data+nudge_val;
elseif strcmp(type_var,'d')==1;
   %
   % move down
   %
   y_data = y_data-nudge_val;
elseif strcmp(type_var,'l')==1;
   %
   % move left
   %
   x_data = x_data-nudge_val_x;
elseif strcmp(type_var,'r')==1;
   %
   % mobe right
   %
   x_data = x_data+nudge_val_x;
end;
set(gco,'XData',x_data,'YData',y_data);

%
% end of nudge_fcn.m
%
