function print_chow(tm,curr_ini,beta,aind)

fout = fopen(tm.outputfile,'at');
%
if aind==1;
   [my_fmat,lrmat,dff,dflr,fpmat,lrpmat,dstr,abort,chow_ss,chow_bp,df_ss,df_bp,chow_dates,from_to_vec,chow_ss_pval,chow_bp_pval] = chowft(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0,tm.modelfile,tm.modelsdir,1);
else;
   [my_fmat,lrmat,dff,dflr,fpmat,lrpmat,dstr,abort,chow_ss,chow_bp,df_ss,df_bp,chow_dates,from_to_vec,chow_ss_pval,chow_bp_pval] = chowft(tm.Z0,tm.Z1,tm.Z2,beta,tm.d,tm.dcoint,curr_ini.T0,tm.samplebeg,tm.sampleend,tm.freq,0);
end;
%
if isempty(my_fmat)==0;
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\subsection*{Chow forecast tests}\n\n');
      for i=1:tm.n;
         vari = strrep(tm.myvars(i,:),' ','');
         fprintf(fout,'\\begin{tabular}{ll}\n');
         fprintf(fout,'$H_0$: & Short run coefficients in equation %s are constant for date $t$ relative to date $t+1$ \\\\\n',txt2ltxmath(vari));
         fprintf(fout,'$H_A$: & Short run coefficients in equation %s are not constant for date $t$ relative to date $t+1$ \\\\\n',txt2ltxmath(vari));
         fprintf(fout,'\\end{tabular}\n\n\\begin{tabular}{rrrr}\n');
         if curr_ini.sscorrect==0;
            fprintf(fout,'$t$ & LR & df & $p$-value \\\\\n');
            for j=1:size(lrmat,1);
               fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],dstr(j,:),lrmat(j,i),dflr(j,:),lrpmat(j,i));
            end;
         else;
            fprintf(fout,'$t$ & F & df & $p$-value\n\n');
            for j=1:size(lrmat,1);
               fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],dstr(j,:),my_fmat(j,i),dff(j,1),dff(j,2),fpmat(j,i));
            end;
         end;
         fprintf(fout,'\\end{tabular}\n\n');
         if i<tm.n;
            fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
         else;
            fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
         end;
      end;
   else;
      fprintf(fout,'  Chow forecast tests\n');
      fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~\n\n');
      for i=1:tm.n;
         vari = strrep(tm.myvars(i,:),' ','');
         fprintf(fout,'Null hypothesis:        Short run coefficients in equation %s\n',vari);
         fprintf(fout,'                        are constant for date t relative to date t+1\n');
         fprintf(fout,'Alternative hypothesis: Short run coefficients in equation %s\n',vari);
         fprintf(fout,'                        are not constant for date t relative to date t+1\n\n');
         if curr_ini.sscorrect==0;
            fprintf(fout,' t                 LR          df        p-value\n\n');
            for j=1:size(lrmat,1);
               fprintf(fout,['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %3.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],dstr(j,:),lrmat(j,i),dflr(j,:),lrpmat(j,i));
            end;
         else;
            fprintf(fout,' t                  F             df           p-value\n\n');
            for j=1:size(lrmat,1);
               fprintf(fout,['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      (%3.0f,%3.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],dstr(j,:),my_fmat(j,i),dff(j,1),dff(j,2),fpmat(j,i));
            end;
         end;
         fprintf(fout,'\n');
         if i<tm.n;
            fprintf(fout,'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
         else;
            fprintf(fout,'===============================================================================\n\n');
         end;
      end;
   end;
end;
if isempty(chow_ss)==0;
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\subsection*{Chow sample-split tests}\n\n');
      fprintf(fout,'\\begin{tabular}{ll}\n');
      fprintf(fout,'$H_0$: & Short run coefficients are constant over the whole sample \\\\\n');
      fprintf(fout,'$H_A$: & Short run coefficients are not constant with a structural break in period $t$ \\\\\n');
      fprintf(fout,'\\end{tabular}\n\n\\begin{tabular}{rrrr}\n');
      fprintf(fout,'$t$ & SS & df & $p$-value \\\\\n');
      for j=1:size(chow_ss,1);
         fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],chow_dates(j,:),chow_ss(j,1),df_ss(j,1),chow_ss_pval(j,1));
      end;
      fprintf(fout,'\\end{tabular}\n\n\\halfruler\n\n');
      fprintf(fout,'\\subsection*{Chow break-point tests}\n\n');
      fprintf(fout,'\\begin{tabular}{ll}\n');
      fprintf(fout,'$H_0$: & Short run coefficients are constant over the whole sample \\\\\n');
      fprintf(fout,'$H_A$: & Short run coefficients are not constant with a structural break in period $t$ \\\\\n');
      fprintf(fout,'\\end{tabular}\n\n\\begin{tabular}{rrrr}\n');
      fprintf(fout,'$t$ & F & df & $p$-value \\\\\n');
      for j=1:size(chow_bp,1);
         if isequal(chow_bp(j,1),0)==0;
            fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],chow_dates(j,:),chow_bp(j,1),df_bp(j,1),df_bp(j,2),chow_bp_pval(j,1));
         end;
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      fprintf(fout,'\\ruler\n\n%==============================================================================\n\n');
   else;
      fprintf(fout,'  Chow sample-split tests\n');
      fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      fprintf(fout,'Null hypothesis:        Short run coefficients are constant over the\n');
      fprintf(fout,'                        whole sample\n');
      fprintf(fout,'Alternative hypothesis: Short run coefficients are not constant with\n');
      fprintf(fout,'                        a structural break in period t\n\n');
      fprintf(fout,' t                 SS          df        p-value\n\n');
      for j=1:size(chow_ss,1);
         fprintf(fout,['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %3.0f        %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],chow_dates(j,:),chow_ss(j,1),df_ss(j,1),chow_ss_pval(j,1));
      end;
      fprintf(fout,'\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      fprintf(fout,'  Chow break-point tests\n');
      fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~\n\n');
      fprintf(fout,'Null hypothesis:        Short run coefficients are constant over the\n');
      fprintf(fout,'                        whole sample\n');
      fprintf(fout,'Alternative hypothesis: Short run coefficients are not constant with\n');
      fprintf(fout,'                        a structural break in period t\n\n');
      fprintf(fout,' t                  F             df           p-value\n\n');
      for j=1:size(chow_bp,1);
         if isequal(chow_bp(j,1),0)==0;
            fprintf(fout,['%s      %' num2str(8+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      (%3.0f,%3.0f)        %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],chow_dates(j,:),chow_bp(j,1),df_bp(j,1),df_bp(j,2),chow_bp_pval(j,1));
         end;
      end;
      fprintf(fout,'\n===============================================================================\n\n');
   end;
end;
fclose(fout);

%
% end of print_chow.m
%
