function print_firstdiffstests(tm,curr_ini,beta,alpha,Psi,epsilon,Sigma_theta,beta_df,alpha_df,local_df,c_ind)

evars = tm.myvars;
if strcmp(tm.xvars1,'')==0;
   xvars1 = vecstr(tm.xvars1);
else;
   xvars1 = '';
end;
if strcmp(tm.xvars0,'')==0;
   xvars0 = vecstr(tm.xvars0);
else;
   xvars0 = '';
end;
allvars = strvcat(evars,xvars1,xvars0);
evars = allvars(1:tm.n,:);
if tm.q1>0;
   xvars1 = allvars(tm.n+1:tm.n+tm.q1,:);
end;
if tm.q0>0;
   xvars0 = allvars(tm.n+tm.q1+1:tm.n+tm.q1+tm.q0,:);
end;
%
% compute the tests
%
[results,dfmat,pvals] = exclude_firstdiffs(Psi,alpha,beta,tm.p,tm.pe,tm.epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,tm.T-local_df,Sigma_theta,curr_ini.sscorrect,tm.modelsdir,tm.modelfile,c_ind);
%
num = 1;
fout = fopen(tm.outputfile,'at');
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{Exclusion Tests for First Differences}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   fprintf(fout,'\\header{Wald-type test statistic}\n');
   for i=1:tm.n;
      vari = strrep(tm.myvars(i,:),' ','');
      fprintf(fout,'\n\\begin{tabular}{rrrr}\n');
      fprintf(fout,'$H_0$: & \\multicolumn{3}{l}{variables can be excluded from the %s equation} \\\\\n',txt2ltxmath(vari));
      fprintf(fout,'$H_A$: & \\multicolumn{3}{l}{variables cannot be excluded from the %s equation} \\\\[2mm]\n',txt2ltxmath(vari));
      if curr_ini.sscorrect==0;
         fprintf(fout,'Variables & W & df & $p$-value \\\\\n');
      else;
         fprintf(fout,'Variables & F & df & $p$-value \\\\\n');
      end;
      %
      % Lagged endogenous
      %
      if (tm.p>1)&(tm.n>2);
         for j=1:tm.n;
            if j~=i;
               if results.individual(num,1)>0;
                  if curr_ini.sscorrect==0;
                     fprintf(fout,['$\\Delta$ %s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(strtrim(evars(j,:))),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
                  else;
                     fprintf(fout,['$\\Delta$ %s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(strtrim(evars(j,:))),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
                  end;
               else;
                  fprintf(fout,'$\\Delta$ %s & \\multicolumn{3}{l}{Not computed} \\\\\n',txt2ltxmath(strtrim(evars(j,:))));
               end;
               num = num+1;
            end;
         end;
         %
         % all endogenous
         %
         if results.endo(i,1)>0;
            if curr_ini.sscorrect==0;
               fprintf(fout,['All above & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results.endo(i,1),dfmat.endo(i,1),pvals.endo(i,1));
            else;
               fprintf(fout,['All above & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\n'],results.endo(i,1),dfmat.endo(i,1),dfmat.endo(i,2),pvals.endo(i,1));
            end;
         else;
            fprintf(fout,'All above & \\multicolumn{3}{l}{Not computed} \\\\\n');
         end;
      end;
      %
      % Exogenous I(1)
      %
      if (tm.q1>0)&(tm.pe>0);
         for j=1:tm.q1;
            if results.individual(num,1)>0;
               if curr_ini.sscorrect==0;
                  fprintf(fout,['$\\Delta$ %s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(strtrim(xvars1(j,:))),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
               else;
                  fprintf(fout,['$\\Delta$ %s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(strtrim(xvars1(j,:))),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
               end;
            else;
               fprintf(fout,'$\\Delta$ %s & \\multicolumn{3}{l}{Not computed} \\\\\n',txt2ltxmath(strtrim(xvars1(j,:))));
            end;
            num = num+1;
         end;
      end;
      %
      % Exogenous I(0)
      %
      if tm.q0>0;
         for j=1:tm.q0;
            if results.individual(num,1)>0;
               if curr_ini.sscorrect==0;
                  fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(strtrim(xvars0(j,:))),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
               else;
                  fprintf(fout,['%s & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],txt2ltxmath(strtrim(xvars0(j,:))),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
               end;
            else;
               fprintf(fout,'%s & \\multicolumn{3}{l}{Not computed} \\\\\n',txt2ltxmath(strtrim(xvars0(j,:))));
            end;
            num = num+1;
         end;
      end;
      %
      % All exogenous
      %
      if (isfield(results,'exo')==1)&(tm.q1+tm.q0>1);
         if results.exo(i,1)>0;
            if curr_ini.sscorrect==0;
               fprintf(fout,['All exogenous & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results.exo(i,1),dfmat.exo(i,1),pvals.exo(i,1));
            else;
               fprintf(fout,['All exogenous & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results.exo(i,1),dfmat.exo(i,1),dfmat.exo(i,2),pvals.exo(i,1));
            end;
         else;
            fprintf(fout,'All exogenous &  \\multicolumn{3}{l}{Not computed} \\\\\n');
         end;
      end;
      %
      % If there's a test for all variables
      %
      if isfield(results,'full')==1;
         if results.full(i,1)>0;
            if curr_ini.sscorrect==0;
               fprintf(fout,['All & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results.full(i,1),dfmat.full(i,1),pvals.full(i,1));
            else;
               fprintf(fout,['All & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & (%0.0f,%0.0f) & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results.full(i,1),dfmat.full(i,1),dfmat.full(i,2),pvals.full(i,1));
            end;
         else;
            fprintf(fout,'All & \\multicolumn{3}{l}{Not computed} \\\\\n');
         end;
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if i<tm.n;
         fprintf(fout,'\\halfruler\n\n%%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n');
      else;
         fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
      end;
   end;
else;
   fprintf(fout,['EXCLUSION TESTS FOR FIRST DIFFERENCES\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   fprintf(fout,'  Wald-type test statistic\n  ~~~~~~~~~~~~~~~~~~~~~~~~\n');
   for i=1:tm.n;
      vari = strrep(tm.myvars(i,:),' ','');
      fprintf(fout,'\nNull Hypothesis:        variables can be excluded from the %s equation \n',vari);
      fprintf(fout,'Alternative Hypothesis: variables cannot be excluded from the %s equation \n\n',vari);
      if curr_ini.sscorrect==0;
         fprintf(fout,'Variables           W        df    p-value \n');
      else;
         fprintf(fout,'Variables           F         df      p-value \n');
      end;
      if (tm.p>1)&(tm.n>2);
         for j=1:tm.n;
            if j~=i;
               if results.individual(num,1)>0;
                  if curr_ini.sscorrect==0;
                     fprintf(fout,['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %3.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],evars(j,:),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
                  else;
                     fprintf(fout,['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%0.0f,%0.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],evars(j,:),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
                  end;
               else;
                  fprintf(fout,'Diffs of %s:    Not computed \n',evars(j,:));
               end;
               num = num+1;
            end;
         end;
         %
         % all endogenous
         %
         if results.endo(i,1)>0;
            if curr_ini.sscorrect==0;
               fprintf(fout,['All above:      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %3.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results.endo(i,1),dfmat.endo(i,1),pvals.endo(i,1));
            else;
               fprintf(fout,['All above:      %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%0.0f,%0.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results.endo(i,1),dfmat.endo(i,1),dfmat.endo(i,2),pvals.endo(i,1));
            end;
         else;
            fprintf(fout,'All above:      Not computed \n');
         end;
      end;
      %
      % Exogenous I(1)
      %
      if (tm.q1>0)&(tm.pe>0);
         for j=1:tm.q1;
            if results.individual(num,1)>0;
               if curr_ini.sscorrect==0;
                  fprintf(fout,['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %3.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],xvars1(j,:),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
               else;
                  fprintf(fout,['Diffs of %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%0.0f,%0.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],xvars1(j,:),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
               end;
            else;
               fprintf(fout,'Diffs of %s:    Not computed \n',xvars1(j,:));
            end;
            num = num+1;
         end;
      end;
      %
      % Exogenous I(0)
      %
      if tm.q0>0;
         for j=1:tm.q0;
            if results.individual(num,1)>0;
               if curr_ini.sscorrect==0;
                  fprintf(fout,['         %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %3.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],xvars0(j,:),results.individual(num,1),dfmat.individual(num,1),pvals.individual(num,1));
               else;
                  fprintf(fout,['         %s:    %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%0.0f,%0.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],xvars0(j,:),results.individual(num,1),dfmat.individual(num,1),dfmat.individual(num,2),pvals.individual(num,1));
               end;
            else;
               fprintf(fout,'         %s:    Not computed \n',xvars0(j,:));
            end;
            num = num+1;
         end;
      end;
      %
      % All exogenous
      %
      if (isfield(results,'exo')==1)&(tm.q1+tm.q0>1);
         if results.exo(i,1)>0;
            if curr_ini.sscorrect==0;
               fprintf(fout,['All exogenous:  %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %3.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results.exo(i,1),dfmat.exo(i,1),pvals.exo(i,1));
            else;
               fprintf(fout,['All exogenous:  %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%0.0f,%0.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results.exo(i,1),dfmat.exo(i,1),dfmat.exo(i,2),pvals.exo(i,1));
            end;
         else;
            fprintf(fout,'All exogenous:  Not computed \n');
         end;
      end;
      %
      % If there's a test for all variables
      %
      if isfield(results,'full')==1;
         if results.full(i,1)>0;
            if curr_ini.sscorrect==0;
               fprintf(fout,['All:            %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %3.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results.full(i,1),dfmat.full(i,1),pvals.full(i,1));
            else;
               fprintf(fout,['All:            %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%0.0f,%0.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results.full(i,1),dfmat.full(i,1),dfmat.full(i,2),pvals.full(i,1));
            end;
         else;
            fprintf(fout,'All:            Not computed \n');
         end;
      end;
      if i<tm.n;
         fprintf(fout,'\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n');
      else;
         fprintf(fout,'\n===============================================================================\n\n');
      end;
   end;
end;

fclose(fout);

%
% end of print_firstdiffstests.m
%
