function print_jo_hansen(tm,curr_ini,my_df)

fout = fopen(tm.outputfile,'at');
%
if tm.r>0;
   if tm.evalue<1;
      if ((curr_ini.fluctest==1)|(curr_ini.nyblom==1));
         if curr_ini.fullrec==1;
            if tm.q1==0;
               [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = reclambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,my_df,tm.deterselect);
            else;
               [nyblomT,nyblomcorr] = boot_nyblom_partial(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.T);
               evaluet = 0;
               tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
            end;
         else;
            if tm.q1==0;
               [lambdaT,lambdastd,sigmastd,tauT,nyblomT,nyblomcorr,xisumT,xistdT,evaluet,tT,abort] = rectlambda(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.d,curr_ini.T0,my_df,tm.deterselect);
            else;
               [nyblomT,nyblomcorr] = boot_nyblom_full(tm.Z0,tm.Z1,tm.Z2,tm.r,tm.p,tm.q1,tm.d,curr_ini.T0,tm.df,tm.deterselect,tm.T);
               evaluet = 0;
               tT = (1/tm.T)*((tm.T+1-max(size(nyblomT))):1:tm.T);
            end;
         end;
         if (isempty(lambdaT)==0)|(isempty(nyblomT)==0);
            if (curr_ini.fluctest==1)&(tm.q1+tm.q0==0)&(tm.datad==0);
               datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
               dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));
               tauT = max(tauT')';
               pval = 1-ploberger_cdf(tauT,1);
               if curr_ini.texoutputformat>=2;
                  fprintf(fout,'\\header{Hansen-Johansen fluctuation tests}\n\n');
                  fprintf(fout,'\\begin{tabular}{ll}\n');
                  fprintf(fout,'$H_0$: & $\\lambda_i$ is constant \\\\\n');
                  fprintf(fout,'$H_A$: & $\\lambda_i$ is not constant \\\\[2mm]\n');
                  fprintf(fout,' & Using the statistic \\\\\n');
                  if curr_ini.transeig==1;
                     fprintf(fout,' & HJ($i,1$) = $\\sup_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} \\tau_{t|T}(\\log[\\lambda_i/(1-\\lambda_i)]), \\quad i=1,...,\\mbox{\\rm %1.0f}$ \\\\[3mm]\n',datet,dateT,tm.r);
                  else;
                     fprintf(fout,' & HJ($i,1$) = $\\sup_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} \\tau_{t|T}(\\lambda_i), \\quad i=1,...,\\mbox{\\rm %1.0f}$ \\\\[3mm]\n',datet,dateT,tm.r);
                  end;
                  fprintf(fout,'\\end{tabular}\n\n\\begin{tabular}{rrr}\n');
                  fprintf(fout,'Eigenvalue & HJ($i,1$) & $p$-value \\\\\n');
                  for i=1:tm.r;
                     fprintf(fout,['%0.0f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f & %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],i,tauT(i,1),pval(i,1));
                  end;
                  fprintf(fout,'\\end{tabular}\n\n');
               else;
                  fprintf(fout,'  Hansen-Johansen fluctuation tests\n');
                  fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
                  fprintf(fout,'Null hypothesis:        eig(i) is constant\n');
                  fprintf(fout,'Alternative hypothesis: eig(i) is not constant\n\n');
                  fprintf(fout,'Using the statistic:\n\n');
                  if curr_ini.transeig==1;
                     fprintf(fout,'    HJ(i,1) = sup_{t=%s,...,%s} tau(log[eig(i)/(1-eig(i))]), i=1,...,%1.0f\n\n',datet,dateT,tm.r);
                  else;
                     fprintf(fout,'    HJ(i,1) = sup_{t=%s,...,%s} tau(eig(i)), i=1,...,%1.0f\n\n',datet,dateT,tm.r);
                  end;
                  fprintf(fout,'Eigenvalue       HJ(i,1)      p-value\n\n');
                  for i=1:tm.r;
                     fprintf(fout,['%6.0f       %' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f   %' num2str(6+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],i,tauT(i,1),pval(i,1));
                  end;
               end;
               if min(xistdT)>0;
                  t1 = size(xisumT,2);
                  tauxisumT = xisumT-(xisumT(1,t1)*ones(1,t1));
                  tauxisumT = max(abs(tT.*(tauxisumT./(sqrt(xistdT(1,t1))*ones(1,t1)))));
                  pval = 1-ploberger_cdf(tauxisumT,1);
                  if curr_ini.texoutputformat>=2;
                     fprintf(fout,'\\header{Hansen-Johansen fluctuation test for sum of eigenvalues}\n\n');
                     fprintf(fout,'\\begin{tabular}{ll}\n');
                     fprintf(fout,'$H_0$: & $\\sum_{i=1}^{%0.0f} \\xi_i$ is constant \\\\\n',tm.r);
                     fprintf(fout,'$H_A$: & $\\sum_{i=1}^{%0.0f} \\xi_i$ is not constant \\\\[2mm]\n',tm.r);
                     fprintf(fout,' & Using the transformation $\\xi_i = \\log[\\lambda_i/(1-\\lambda_i)]$, $i=1,...,%1.0f$ \\\\[2mm]\n',tm.r);
                     fprintf(fout,[' & $\\sup_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} \\tau_{t|T}( \\sum_{i=1}^{%0.0f} \\xi_i )$ = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],datet,dateT,tm.r,tauxisumT);
                     fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],pval);
                     fprintf(fout,'\\end{tabular}\n\n');
                  else;
                     fprintf(fout,'\n  Hansen-Johansen fluctuation test for sum of eigenvalues\n');
                     fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
                     fprintf(fout,'Null hypothesis:        sum(xi;1,...,%1.0f) is constant\n',tm.r);
                     fprintf(fout,'Alternative hypothesis: sum(xi;1,...,%1.0f) is not constant\n\n',tm.r);
                     fprintf(fout,'Using the transformation xi=log[eig(i)/(1-eig(i))], i=1,...,%1.0f\n\n',tm.r);
                     fprintf(fout,['sup_{t=%s,...,%s} tau(sum(xi);1) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\np-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f\n'],datet,dateT,tauxisumT,pval);
                  end;
               end;
               if max(evaluet)>=1;
                  [maxevaluet,maxevaluepos] = max(evaluet);
                  datemax = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,maxevaluepos));
                  if curr_ini.texoutputformat>=2;
                     fprintf(fout,'\\vspace*{3mm}\n\\newline\n\\noindent\n\\textbf{WARNING:} The largest non-unit eigenvalue of the companion matrix over the\n');
                     fprintf(fout,'recursion period is greater than unity. It''s largest value\n');
                     fprintf(fout,['is %0.' num2str(curr_ini.decimals,'%0.0f') 'f at date %s\n\n'],maxevaluet,datemax);
                  else;
                     fprintf(fout,'\nWARNING! The largest non-unit eigenvalue of the companion matrix over the\n');
                     fprintf(fout,'         recursion period is greater than unity. It''s largest value\n');
                     fprintf(fout,['         is %0.' num2str(curr_ini.decimals,'%0.0f') 'f at date %s\n'],maxevaluet,datemax);
                  end;
               end;
               if curr_ini.texoutputformat>=2;
                  fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
               else;
                  fprintf(fout,'\n===============================================================================\n\n');
               end;
            end;
            if ((curr_ini.nyblom==1)&(tm.r<tm.n));
               datet = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,1));
               dateT = getdate(tm.samplebeg,tm.sampleend,tm.freq,tT(1,size(tT,2)));
               meannT = (1/size(nyblomT,2))*sum(nyblomT);
               nyblomT = max(nyblomT);
               if curr_ini.texoutputformat>=2;
                  fprintf(fout,'\\header{Nyblom tests for $\\beta$}\n\n');
                  fprintf(fout,'\\begin{tabular}{ll}\n');
                  fprintf(fout,'$H_0$: & $\\beta$ is constant \\\\\n');
                  fprintf(fout,'$H_A$: & $\\beta$ is not constant \\\\[2mm]\n');
                  fprintf(fout,[' & $\\sup_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} Q_{t|T} (\\mbox{\\rm \\#endo vars}=%1.0f,r=%1.0f)$ = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],datet,dateT,tm.n,tm.r,nyblomT(1,1));
                  if tm.nyblom_asymp==1;
                     fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],nyblom_pvalues(tm.n,tm.r,nyblomT(1,1),'max',tm.deterselect));
                  end;
                  fprintf(fout,[' & $\\mean_{t \\in \\{\\mbox{\\rm {\\footnotesize %s}}, \\ldots ,\\mbox{\\rm {\\footnotesize %s}}\\}} Q_{t|T} (\\mbox{\\rm \\#endo vars}=%1.0f,r=%1.0f)$ = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],datet,dateT,tm.n,tm.r,meannT);
                  if tm.nyblom_asymp==1;
                     fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],nyblom_pvalues(tm.n,tm.r,meannT,'mean',tm.deterselect));
                  end;
                  fprintf(fout,'\\end{tabular}\n\n');
                  fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
               else;
                  fprintf(fout,'  Nyblom tests for beta\n');
                  fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~\n\n');
                  fprintf(fout,'Null hypothesis:        beta is constant\n');
                  fprintf(fout,'Alternative hypothesis: beta is not constant\n\n');
                  fprintf(fout,['sup_{t=%s,...,%s} Q(t|T=%s;endo vars=%1.0f,rank=%1.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],datet,dateT,dateT,tm.n,tm.r,nyblomT(1,1));
                  if tm.nyblom_asymp==1;
                     fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],nyblom_pvalues(tm.n,tm.r,nyblomT(1,1),'max',tm.deterselect));
                  end;
                  fprintf(fout,['\nMean Q(t|T=%s;endo vars=%1.0f,rank=%1.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],dateT,tm.n,tm.r,meannT);
                  if tm.nyblom_asymp==1;
                     fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],nyblom_pvalues(tm.n,tm.r,meannT,'mean',tm.deterselect));
                  end;
                  fprintf(fout,'\n===============================================================================\n\n');
               end;
            end;
         end;
      end;
   end;
end;
fclose(fout);

%
% end of print_jo_hansen.m
%
