function print_lagordertest(tm,curr_ini,beta,alpha,Psi,epsilon,Sigma_theta,beta_df,alpha_df,local_df,aind)

c_ind = 0;
if size(tm.restrict,2)==3;
   c_ind = tm.restrict(1,3);
end;
print_flag = 0;
fout = fopen(tm.outputfile,'at');
for lag=1:curr_ini.lagtest;
   if (local_df-lag*(tm.n+tm.q1+tm.q0))>0;
      print_flag = 1;
      adds = '';
      if (tm.p>=2)|(curr_ini.lagtest>1);
         adds = 'S';
      end;
      [results,degfree,mycorrect] = lmlagtest(epsilon,tm.x0,tm.x1,tm.x1_r,tm.x2,tm.p,tm.pe,lag,tm.q1,tm.q0,beta,local_df,aind,tm.modelsdir,tm.modelfile,c_ind,Psi,alpha,tm.Z1,tm.Z2,tm.d);
      if lag==1;
         if curr_ini.texoutputformat>=2;
            fprintf(fout,['\\subsection*{Lag order test' lower(adds) '}\n\n\\header{For $r$=' num2str(tm.r) ', \\mbox{\\rm lags}=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n+tm.q1+tm.dcoint-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
         else;
            fprintf(fout,['LAG ORDER TEST' adds '\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n+tm.q1+tm.dcoint-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
         end;
      end;
      if curr_ini.texoutputformat>=2;
         fprintf(fout,'\\header{LM-type test statistic}\n\n');
         fprintf(fout,'\\begin{tabular}{ll}\n');
         fprintf(fout,'$H_0$: & %0.0f lags \\\\\n',tm.p);
         fprintf(fout,'$H_A$: & %0.0f lags \\\\[2mm]\n',tm.p+lag);
         if mycorrect==0;
            fprintf(fout,['\\multicolumn{2}{l}{LM(%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],degfree(1,1),results(1,1));
            fprintf(fout,['\\multicolumn{2}{l}{$p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],results(1,2));
         else;
            fprintf(fout,['\\multicolumn{2}{l}{F(%0.0f,%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],degfree(1,1),degfree(1,2),results(1,1));
            fprintf(fout,['\\multicolumn{2}{l}{$p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],results(1,2));
         end;
         fprintf(fout,'\\end{tabular}\n\n');
      else;
         fprintf(fout,'  LM-type test statistic\n');
         fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~\n\n');
         fprintf(fout,'Null hypothesis:        %0.0f lags\n',tm.p);
         fprintf(fout,'Alternative hypothesis: %0.0f lags\n\n',tm.p+lag);
         if mycorrect==0;
            fprintf(fout,['LM(%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],degfree(1,1),results(1,1));
            fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results(1,2));
         else;
            fprintf(fout,['F(%0.0f,%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],degfree(1,1),degfree(1,2),results(1,1));
            fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results(1,2));
         end;
         fprintf(fout,'\n');
      end;
   end;
   if (tm.p-lag)>=1;
      [results,degfree,status] = waldlagtest(Psi,alpha,beta,tm.p,tm.pe,lag,epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,local_df,Sigma_theta);
      if status==0;
         print_flag = 1;
         if lag==1;
            if (local_df-(tm.n+tm.q1+tm.q0))<=0;
               if curr_ini.texoutputformat>=2;
                  fprintf(fout,['\\subsection*{Lag order test' lower(adds) '}\n\n\\header{For $r$=' num2str(tm.r) ', \\mbox{\\rm lags}=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
               else;
                  fprintf(fout,['LAG ORDER TEST' adds '\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
               end;
            end;
         end;
         if curr_ini.texoutputformat>=2;
            fprintf(fout,'\\header{Wald-type test statistic}\n\n');
            fprintf(fout,'\\begin{tabular}{ll}\n');
            fprintf(fout,'$H_0$: & %0.0f lags \\\\\n',tm.p-lag);
            fprintf(fout,'$H_A$: & %0.0f lags \\\\\n',tm.p);
            if curr_ini.sscorrect==0;
               fprintf(fout,['\\multicolumn{2}{l}{W(%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],degfree(1,1),results(1,1));
               fprintf(fout,['\\multicolumn{2}{l}{$p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],results(1,2));
            else;
               fprintf(fout,['\\multicolumn{2}{l}{F(%0.0f,%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],degfree(1,1),degfree(1,2),results(1,1));
               fprintf(fout,['\\multicolumn{2}{l}{$p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f} \\\\\n'],results(1,2));
            end;
            fprintf(fout,'\\end{tabular}\n\n');
         else;
            fprintf(fout,'  Wald-type test statistic\n');
            fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
            fprintf(fout,'Null hypothesis:        %0.0f lags\n',tm.p-lag);
            fprintf(fout,'Alternative hypothesis: %0.0f lags\n\n',tm.p);
            if curr_ini.sscorrect==0;
               fprintf(fout,['Wald(%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],degfree(1,1),results(1,1));
               fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results(1,2));
            else;
               fprintf(fout,['F(%0.0f,%0.0f) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],degfree(1,1),degfree(1,2),results(1,1));
               fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results(1,2));
            end;
            fprintf(fout,'\n');
         end;
      end;
   end;
   if print_flag==1;
      if curr_ini.texoutputformat>=2;
         if lag<curr_ini.lagtest;
            fprintf(fout,'\\halfruler\n\n%%==============================================================================\n\n');
         else;
            fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
         end;
      else;
         fprintf(fout,'===============================================================================\n\n');
      end;
   end;
end;
fclose(fout);

%
% end of print_lagordertest.m
%
