function print_resize_legend_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

if isfield(toolbar,'edit')==0;
   return;
end;

if isempty(get(toolbar.edit,'UserData'))==0;
   axeshandles = get(toolbar.print,'UserData');
   legpositions = get(toolbar.edit,'UserData');
else;
   if isempty(get(toolbar.print,'UserData'))==0;
      axeshandles = get(toolbar.print,'UserData');
   else;
      axeshandles = [];
   end;
   legpositions = [];
end;

%
% fix legends
%

if isempty(axeshandles)==0
   count = 0;
   curr_ini = find_inisettings;
   for j=1:size(axeshandles,2);
      if isempty(get(axeshandles(1,j),'UserData'))==0;
         count = count+1;
         old_leg = get(axeshandles(1,j),'UserData');
         oldlegpos = legpositions(count,:);
         leg_ud = get(old_leg,'UserData');
         %
         % get the new axes and legend positions in pixels
         %
         old_ax_units = get(axeshandles(1,j),'Units');
         set(axeshandles(1,j),'Units','pixels');
         ax_pos = get(axeshandles(1,j),'Position');
         set(axeshandles(1,j),'Units','normalized');
%         leg_ud.AxesPosition = get(axeshandles(1,j),'Position');
%         leg_ud.PlotPosition = get(axeshandles(1,j),'Position');
         set(axeshandles(1,j),'Units',old_ax_units);
         old_leg_units = get(old_leg,'Units');
         set(old_leg,'Units','pixels');
         new_legpos = get(old_leg,'Position');
         %
         % compare the lower left corners of axes and legend
         % to determine which quadrant of the axes the legend
         % is located in. the decision rule is to use the old
         % height and width of the legend, but position it based
         % on the quadrant.
         %
         %   upper left quadrant:  upper left corner
         %   upper right quadrant: upper right corner
         %   etc.
         %
         % if outside axes, then use lower left corner
         %
         lower_c = 0;
         left = 0;
         outside = 0;
         %
         % checking left/right
         %
         if (new_legpos(1)<ax_pos(1))|(new_legpos(1)+new_legpos(3)>ax_pos(1)+ax_pos(3));
            outside = 1;
         elseif new_legpos(1)-ax_pos(1)<(ax_pos(1)+ax_pos(3))-(new_legpos(1)+new_legpos(3));
            left = 1;
         end;
         if outside==0;
            if (new_legpos(2)<ax_pos(2))|(new_legpos(2)+new_legpos(4)>ax_pos(2)+ax_pos(4));
               outside = 1;
            elseif new_legpos(2)-ax_pos(2)<(ax_pos(2)+ax_pos(4))-(new_legpos(2)+new_legpos(4));
               lower_c = 1;
            end;
         end;
         %
         % outside or lower-left quadrant
         %
         if (outside==1)|((lower_c==1)&(left==1));
            pos = new_legpos(1:2);
         %
         % lower-right quandrant
         %
         elseif ((lower_c==1)&(left==0));
            pos = [(new_legpos(1)+(new_legpos(3)-oldlegpos(3))) new_legpos(2)];
         %
         % upper-left quadrant
         %
         elseif ((lower_c==0)&(left==1));
            pos = [new_legpos(1) (new_legpos(2)+(new_legpos(4)-oldlegpos(4)))];
         %
         % upper-right quandrant
         %
         else;
            pos = [(new_legpos(1)+(new_legpos(3)-oldlegpos(3))) (new_legpos(2)+(new_legpos(4)-oldlegpos(4)))];
         end;
         %
         % change legend position and size and update legend user data
         %
         set(old_leg,'Position',[pos oldlegpos(3:4)]);
         set(old_leg,'Units','normalized');
%         leg_ud.LegendPosition = get(old_leg,'Position');
         set(old_leg,'Units',old_leg_units,'UserData',leg_ud);  % 
      end;
      if curr_ini.ytick==1;
         fixytix(axeshandles(1,j));
      end;
      if curr_ini.xtick==1;
         fixxtix(axeshandles(1,j));
      end;
   end;
end;

drawnow;

%
% end of print_resize_legend_fcn.m
%
