function print_vardecomp(vardec,std_vardec,n,myvars,myshocks,outputfile,texoutputformat)

curr_ini = find_inisettings;
h = size(vardec,2);
fout = fopen(outputfile,'at');
if texoutputformat>=2;
   fprintf(fout,'\\header{Variance Decompositions}\n\n');
   prt_str = '%s';
   tab_str = 'r';
   shocks = '';
   for i=1:n;
      prt_str = [prt_str ' & %0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
      tab_str = [tab_str 'r'];
      shocks = [shocks ' ' strtrim(myshocks(i,:))];
   end;
else;
   fprintf(fout,'  Variance Decompositions\n');
   fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~\n\n');
   prt_str = '   %s  ';
   head_str = 'period: %0.0f';
   for i=1:n;
      prt_str = [prt_str '   %0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
      head_str = [head_str '     ' myshocks(i,:)];
   end;
end;
for i=1:h;
   vd = vecinv(vardec(:,i),n);
   std_vd = vecinv(std_vardec(:,i),n);
   if texoutputformat>=2;
      fprintf(fout,['\\tabular{' tab_str '}\n']);
      fprintf(fout,'Period %0.0f & %s\n',i,text_latextable(shocks));
      for j=1:n;
         fprintf(fout,[prt_str ' \\\\\n'],txt2ltxmath(strtrim(myvars(j,:))),vd(j,:));
      end;
      fprintf(fout,[' & \\multicolumn{' num2str(n,'%0.0f') '}{c}{asymptotic standard errors} \\\\\n']);
      for j=1:n;
         fprintf(fout,[prt_str ' \\\\\n'],txt2ltxmath(strtrim(myvars(j,:))),std_vd(j,:));
      end;
      fprintf(fout,'\\end{tabular}\n\n');
      if i<h;
         fprintf(fout,'\\halfruler\n\n');
      else;
         fprintf(fout,'\\ruler\n\n%%==============================================================================\n\n');
      end;
   else;
      fprintf(fout,[head_str '\n'],i);
      for j=1:n;
         fprintf(fout,[prt_str '\n'],myvars(j,:),vd(j,:));
      end;
      fprintf(fout,'\nAsymptotic standard errors:\n\n');
      for j=1:n;
         fprintf(fout,[prt_str '\n'],myvars(j,:),std_vd(j,:));
      end;
      if i<h;
         fprintf(fout,'\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      else;
         fprintf(fout,'\n===============================================================================\n\n');
      end;
   end;
end;
fclose(fout);

%
% end of print_vardecomp.m
%
