function catpreview_fcn(pj,epsFilename,tifFilename,preFilename)
%CATPREVIEW Creates an EPS/TIFF preview file.
%CATPREVIEW(PRINTOBJ,EPSFILENAME,TIFFFILENAME,PREFILENAME)
%   PRINTJOBOBJ  - Instance of printjob object
%   EPSFILENAME  - name of the EPS file
%   TIFFFILENAME - name of the TIFF preview file
%   PREFILENAME  - name of the resulting preview file
%   
%   Deletes the EPS and TIFF files when done unless PrintJob.DebugMode is true.

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.5 $  $Date: 2001/04/15 11:59:44 $

if ~exist(epsFilename)
    error( 'No EPS file to concatenate.' )
end
if ~exist(tifFilename)
    error( 'No TIFF file to concatenate.' )
end

hdrFilename=LocMakeHeader(epsFilename,tifFilename);

pFID=fopen(preFilename,'w');
if pFID>0
    %Just checking that I could write to it, get rid of it.
    fclose(pFID);

      delete_file_fcn(preFilename);

%    delete(preFilename)
    
    if isunix
%      dberror = disabledberror_fcn;
%      try
%	[Status, result] = unix(['cat  "' hdrFilename '" "', ...
%		    epsFilename,'" "' tifFilename '" > "' preFilename ...
%		    '"']);
%      catch
	% Try unix with one argument if last call fails
	Status = unix(['cat  "' hdrFilename '" "', ...
		       epsFilename,'" "' tifFilename '" > "' preFilename ...
		       '"']);
	result = '';
%      end
%      enabledberror_fcn(dberror);
    elseif strncmp(computer,'PC',2)
        [Status, result] = privdos_fcn( pj, ['copy /B "' hdrFilename '" +"', ...
                epsFilename,'" /B +"' tifFilename '" "' preFilename '"']);
    elseif strncmp(computer,'MAC',3)
        error('Multiple file copying not supported on MAC');
    end % if computer type
else
    error(['Could not open file ' preFilename])
end

%if ~pj.DebugMode
%    delete(epsFilename);
%    delete(tifFilename);
%    delete(hdrFilename);
%end

%
% end of catpreview_fcn.m
%
