function [hl,hobjs] = find_legend(ha)
%FIND_LEGEND Return current legend handle or error out if none.
if nargin==0
  hl = findobj(allchild(find_gcf),'Tag','legend');
else
  hl = findobj(allchild(find_gcf(ha)),'Tag','legend');
end
hobjs = [];
if nargin>0
  if length(ha)~=1
    error('Requires a single axis handle.');
  end
  ud = get(hl,{'userdata'});
  for i=1:length(ud)
    if isfield(ud{i},'PlotHandle') & ud{i}.PlotHandle == ha
      hl = hl(i);
      hobjs = ud{i}.LabelHandles;
      return
    end
  end
  hl = []; % None found
  hobjs = [];
end

%
% end of find_legend.m
%
