function ptrestorehg_fcn( pt, h )
%FORMAT Method that restores a Figure after formating it for output.
%   Input of PrintTemplate object and a Figure to modify.
%   Figure has numerous properites restore to previous values modified
%   to account for template settings.

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.3 $  $Date: 2001/04/15 11:59:46 $

if pt.DebugMode
    disp(['Restoring Figure ' num2str(h)])
    pt
end

% Output Axes with same tick MARKS as on screen
if pt.AxesFreezeTicks
    set( pt.tickState.handles, {'XTickMode','YTickMode','ZTickMode'}, pt.tickState.values )
    pt.tickState = {};
end

% Output Axes with same tick LIMITS as on screen
if pt.AxesFreezeLimits
    set( pt.limState.handles, {'XLimMode','YLimMode','ZLimMode'}, pt.limState.values )
    pt.limState = {};
end

