function save_axes_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');
old_axes = gca;

%cp = get(h,'CurrentPoint');
%pos = get(toolbar.addtext,'Position');
%if cp(2)>=pos(2)-6;
%   set(h,'Pointer','arrow');
%   return;
%else;
   set(h,'Pointer','crosshair');
%end;

my_lines = findobj(old_axes,'Type','line')';
for i=1:size(my_lines,2);
   delete(my_lines(1,i));
end;

curr_ini = find_inisettings;

%
% axes
%

ax_pos = get(old_axes,'Position');
delete(old_axes);

new_axes = axes('Units','pixels', ...
   'Position',ax_pos, ...
   'Layer','top', ...
   'Visible','off', ...
   'XLim',[0 1], ...
   'YLim',[0 1], ...
   'ZLim',[0 1], ...
   'FontName',curr_ini.axes_fontname, ...
   'FontSize',curr_ini.axes_fontsize, ...
   'FontAngle',curr_ini.axes_fontangle, ...
   'FontWeight',curr_ini.axes_fontweight, ...
   'FontUnits',curr_ini.axes_fontunits, ...
   'Color',[1 1 1], ...
   'XColor',curr_ini.axes_color, ...
   'YColor',curr_ini.axes_color, ...
   'ZColor',curr_ini.axes_color, ...
   'Tag','NewAxes');

if curr_ini.xgrid==1;
   set(new_axes,'XGrid','on');
else;
   set(new_axes,'XGrid','off');
end;
if curr_ini.ygrid==1;
   set(new_axes,'YGrid','on');
else;
   set(new_axes,'YGrid','off');
end;
if curr_ini.zgrid==1;
   set(new_axes,'ZGrid','on');
else;
   set(new_axes,'ZGrid','off');
end;
if curr_ini.box==1;
   set(new_axes,'Box','on');
else;
   set(new_axes,'Box','off');
end;

%
% title
%

set(get(new_axes,'Title'),'String',' ', ...
   'Color',curr_ini.title_color, ...
   'FontName',curr_ini.title_fontname, ...
   'FontSize',curr_ini.title_fontsize, ...
   'FontAngle',curr_ini.title_fontangle, ...
   'FontWeight',curr_ini.title_fontweight, ...
   'FontUnits',curr_ini.title_fontunits);

%
% standard context menu for the title
%

title_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',title_context_menu,'Label','Edit','Callback','set(get(gca,''Title''),''Editing'',''on'')');
uimenu('Parent',title_context_menu,'Separator','on','Label','Font','Callback','change_title_font');
uimenu('Parent',title_context_menu,'Label','Font Color','Callback','change_title_color');
set(get(new_axes,'Title'),'UIContextMenu',title_context_menu,'ButtonDownFcn','check_title_fcn');

%
% x, y, z labels
%

set(get(new_axes,'XLabel'),'String',' ', ...
   'Color',curr_ini.label_color, ...
   'FontName',curr_ini.label_fontname, ...
   'FontSize',curr_ini.label_fontsize, ...
   'FontAngle',curr_ini.label_fontangle, ...
   'FontWeight',curr_ini.label_fontweight, ...
   'FontUnits',curr_ini.label_fontunits);

set(get(new_axes,'YLabel'),'String',' ', ...
   'Color',curr_ini.label_color, ...
   'FontName',curr_ini.label_fontname, ...
   'FontSize',curr_ini.label_fontsize, ...
   'FontAngle',curr_ini.label_fontangle, ...
   'FontWeight',curr_ini.label_fontweight, ...
   'FontUnits',curr_ini.label_fontunits);

set(get(new_axes,'ZLabel'),'String',' ', ...
   'Color',curr_ini.label_color, ...
   'FontName',curr_ini.label_fontname, ...
   'FontSize',curr_ini.label_fontsize, ...
   'FontAngle',curr_ini.label_fontangle, ...
   'FontWeight',curr_ini.label_fontweight, ...
   'FontUnits',curr_ini.label_fontunits);

%
% create a context menu for x-label
%
xlabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',xlabel_context_menu,'Label','Edit','Callback','set(get(gca,''XLabel''),''Editing'',''on'')');
uimenu('Parent',xlabel_context_menu,'Separator','on','Label','Font','Callback','change_xlabel_font');
uimenu('Parent',xlabel_context_menu,'Label','Font Color','Callback','change_xlabel_color');
set(get(new_axes,'XLabel'),'UIContextMenu',xlabel_context_menu,'ButtonDownFcn','check_xlabel_fcn');
%
% create a context menu for y-label
%
ylabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',ylabel_context_menu,'Label','Edit','Callback','set(get(gca,''YLabel''),''Editing'',''on'')');
uimenu('Parent',ylabel_context_menu,'Separator','on','Label','Font','Callback','change_ylabel_font');
uimenu('Parent',ylabel_context_menu,'Label','Font Color','Callback','change_ylabel_color');
set(get(new_axes,'YLabel'),'UIContextMenu',ylabel_context_menu,'ButtonDownFcn','check_ylabel_fcn');
%
% create a context menu for y-label
%
zlabel_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
uimenu('Parent',zlabel_context_menu,'Label','Edit','Callback','set(get(gca,''ZLabel''),''Editing'',''on'')');
uimenu('Parent',zlabel_context_menu,'Separator','on','Label','Font','Callback','change_zlabel_font');
uimenu('Parent',zlabel_context_menu,'Label','Font Color','Callback','change_zlabel_color');
set(get(new_axes,'ZLabel'),'UIContextMenu',zlabel_context_menu,'ButtonDownFcn','check_zlabel_fcn');

%
% reset figure button up, down and motion function
%

set(h,'WindowButtonUpFcn','');
set(h,'WindowButtonMotionFcn','pointer_crosshair');
set(h,'WindowButtonDownFcn','addaxes_fcn');
set(toolbar.print,'UserData',[myaxes new_axes]);

%
% Show axes
%

set(new_axes,'Units','normalized','Visible','on');

%
% end of save_axes_fcn.m
%
