function show_archtest(fig_handle,tm,curr_ini,ind)

set(fig_handle,'Visible','off');
drawnow;
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
[results2,dfmat] = arch(tm.epsilon,tm.freq,tm.T-tm.df);
%
% and now the multivariate tests
%
[m_res,m_df] = march(tm.epsilon,tm.T-tm.df,curr_ini.rest_march,curr_ini.sscorrect);
%
prt_val = ['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
archtext = strvcat(' ',['ARCH TESTS (for' res_str ' rank=' num2str(tm.r) ')']);
numchar = size(archtext,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
archtext = strvcat(archtext,addcorr,' ');
sp_str = spacestr(curr_ini.decimals-2);
%
% if there are multivariate tests
%
if isempty(m_res)==0;
   archtext = strvcat(archtext,'Multivariate ARCH Test','~~~~~~~~~~~~~~~~~~~~~~',' ');
   if curr_ini.rest_march==1;
      archtext = strvcat(archtext,'  (MARCH model has diagonal lag matrix)',' ');
   end;
   if curr_ini.sscorrect==0;
      archtext = strvcat(archtext,['LM(' num2str(m_df(1,1),'%0.0f') ') = ' num2str(m_res(1,1),prt_val)],['p-value = ' num2str(m_res(1,2),prt_val)],' ');
   else;
      archtext = strvcat(archtext,['F(' num2str(m_df(1,1),'%0.0f') ',' num2str(m_df(1,2),'%0.0f') ') = ' num2str(m_res(1,1),prt_val)],['p-value = ' num2str(m_res(1,2),prt_val)],' ');
   end;
   archtext = strvcat(archtext,'--------------------------------------------------',' ');
end;
%
if curr_ini.sscorrect==0;
   archtext = strvcat(archtext,['LM tests for 1st order ARCH with ' num2str(dfmat(1,1),'%0.0f') ' deg. freedom:'],' ');
else;
   archtext = strvcat(archtext,['F-tests based on LM for 1st order ARCH with (' num2str(dfmat(1,1),'%0.0f') ',' num2str(dfmat(1,2),'%0.0f') ') deg. freedom:'],' ');
end;
archtext = strvcat(archtext,['Equation       Test  ' sp_str '    p-value']);
for i=1:tm.n;
   out = sprintf([' %s %s %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,results2(i,1),results2(i,3));
   archtext = strvcat(archtext,out);
end;
archtext = strvcat(archtext,' ');
if strcmp(tm.freq,'')==0;
   mystr = '4';
   if strcmp(tm.freq,'m')==1;
      mystr = '12';
   end;
   if curr_ini.sscorrect==0;
      archtext = strvcat(archtext,['LM tests for 1st-' mystr 'th order ARCH with 'num2str(dfmat(1,2),'%0.0f') ' deg. freedom:'],' ');
   else;
      archtext = strvcat(archtext,['F-tests based on LM for 1st-' mystr 'th order ARCH with (' num2str(dfmat(1,3),'%0.0f') ',' num2str(dfmat(1,4),'%0.0f') ') deg. freedom:'],' ');
   end;
   archtext = strvcat(archtext,['Equation       Test  ' sp_str '    p-value']);
   for i=1:tm.n;
      out = sprintf([' %s %s %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f      %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tm.mv2add,results2(i,2),results2(i,4));
      archtext = strvcat(archtext,out);
   end;
   archtext = strvcat(archtext,' ');
end;
textgui(archtext,'ARCH Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_archtest.m
%
