function show_lagordertest(fig_handle,beta,alpha,Psi,Sigma_theta,tm,curr_ini,ind,aind)

set(fig_handle,'Visible','off');
drawnow;
%
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
%
c_ind = 0;
if size(tm.restrict,2)==3;
   c_ind = tm.restrict(1,3);
end;
%
prt_val = ['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
lagstr = strvcat(' ','No tests have been computed!',' ');
for lag=1:curr_ini.lagtest;
   if (tm.T-tm.df-lag*(tm.n+tm.q1+tm.q0))>0;
      adds = '';
      if tm.p>=2;
         adds = 'S';
      end;
      [results,degfree,mycorrect] = lmlagtest(tm.epsilon,tm.x0,tm.x1,tm.x1_r,tm.x2,tm.p,tm.pe,lag,tm.q1,tm.q0,beta,tm.T-tm.df,aind,tm.modelsdir,tm.modelfile,c_ind,Psi,alpha,tm.Z1,tm.Z2,tm.d);
      if lag==1;
         lagstr = strvcat(' ',['LAG ORDER TEST' adds ' (for' res_str ' rank=' num2str(tm.r) ')']);
         numchar = size(lagstr,2);
         addcorr = '';
         for i=1:numchar;
            addcorr = strcat(addcorr,'=');
         end;
         lagstr = strvcat(lagstr,addcorr,' ');
      end;
      lagstr = strvcat(lagstr,'  LM-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~',' ');
      lagstr = strvcat(lagstr,['Null hypothesis:        ' num2str(tm.p) ' lags'],['Alternative hypothesis: ' num2str(tm.p+lag) ' lags'],' ');
      if mycorrect==0;
         lagstr = strvcat(lagstr,['LM(' num2str(degfree(1,1),'%0.0f') ') = ' num2str(results(1,1),prt_val)]);
      else;
         lagstr = strvcat(lagstr,['F(' num2str(degfree(1,1),'%0.0f') ',' num2str(degfree(1,2)) ') = ' num2str(results(1,1),prt_val)]);
      end;
      lagstr = strvcat(lagstr,['p-value = ' num2str(results(1,2),prt_val)],' ');
   end;
   if (tm.p-lag)>=1;
      [results,degfree,status] = waldlagtest(Psi,alpha,beta,tm.p,tm.pe,lag,tm.epsilon,tm.Z1,tm.Z2,tm.q1,tm.q0,tm.d,tm.T-tm.df,Sigma_theta);
      if status==0;
         if lag==1;
            if (tm.T-tm.df-(tm.n+tm.q1+tm.q0))<=0;
               lagstr = strvcat(' ',['LAG ORDER TEST (for' res_str ' rank=' num2str(tm.r) ')']);
               numchar = size(lagstr,2);
               addcorr = '';
               for i=1:numchar;
                  addcorr = strcat(addcorr,'=');
               end;
               lagstr = strvcat(lagstr,addcorr,' ')
            end;
         end;
         lagstr = strvcat(lagstr,'  Wald-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~~~',' ');
         lagstr = strvcat(lagstr,['Null hypothesis:        ' num2str(tm.p-lag) ' lags'],['Alternative hypothesis: ' num2str(tm.p) ' lags'],' ');
         if curr_ini.sscorrect==0;
            lagstr = strvcat(lagstr,['Wald(' num2str(degfree(1,1),'%0.0f') ') = ' num2str(results(1,1),prt_val)]);
         else;
            lagstr = strvcat(lagstr,['F(' num2str(degfree(1,1),'%0.0f') ',' num2str(degfree(1,2)) ') = ' num2str(results(1,1),prt_val)]);
         end;
         lagstr = strvcat(lagstr,['p-value = ' num2str(results(1,2),prt_val)],' ');
      end;
   end;
end;
textgui(lagstr,'Lag Order Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_lagordertest.m
%
