function show_stationarity(fig_handle,tm,curr_ini)

set(fig_handle,'Visible','off');
drawnow;
%
% compute the tests
%
if (tm.deterselect(1,1)==1)|(tm.deterselect(1,3)==1);
   [tests,deg_free,pvals] = coint_stationarity(tm.Z0,tm.Z1,tm.Z2,tm.epsilon,tm.r,tm.q1,tm.dcoint,tm.df,curr_ini.sscorrect);
else;
   [tests,deg_free,pvals] = coint_stationarity_dcoint(tm.Z0,tm.Z1,tm.Z2,tm.myvars,tm.epsilon,tm.beta(:,1:tm.r),tm.r,tm.q1,tm.dcoint,tm.df,curr_ini.sscorrect,curr_ini.convcrit,curr_ini.betagrad,curr_ini.maxit,1);
end;
%
% create the output text string
%
txt = strvcat(' ',['TESTING STATIONARITY (for rank=' num2str(tm.r) ')']);
numchar = size(txt,2);
addtxt = '';
for i=1:numchar;
   addtxt = strcat(addtxt,'=');
end;
txt = strvcat(txt,addtxt,' ');
txt = strvcat(txt,'  LR-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~');
%
add_str = '';
if (tm.deterselect(1,3)==1)|(tm.deterselect(1,4)==1);
   add_str = ' trend';
end;
%
sp_str = spacestr(curr_ini.decimals-2);
txt = strvcat(txt,' ',['Null Hypothesis:        variable k is' add_str ' stationary' ]);
txt = strvcat(txt,['Alternative Hypothesis: variable k is not' add_str ' stationary'],' ');
if curr_ini.sscorrect==0;
   txt = strvcat(txt,[' k        LR   ' sp_str '   df     p-value'],' ');
   for i=1:size(tests,1);
      out = sprintf([' %s     %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    %2.0f     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tests(i,1),deg_free(i,1),pvals(i,1));
      txt = strvcat(txt,out);
   end;
else;
   txt = strvcat(txt,[' k         F   ' sp_str '      df        p-value'],' ');
   for i=1:size(tests,1);
      out = sprintf([' %s     %' num2str(4+curr_ini.decimals,'%0.0f') '.' num2str(curr_ini.decimals,'%0.0f') 'f    (%2.0f,%3.0f)     %0.' num2str(curr_ini.decimals,'%0.0f') 'f'],tm.myvars(i,:),tests(i,1),deg_free(i,1),deg_free(i,2),pvals(i,1));
      txt = strvcat(txt,out);
   end;
end;
txt = strvcat(txt,' ');
%
% display the results
%
realscrsz = get(0,'ScreenSize');
textgui(txt,'Stationarity Restrictions on Beta',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
%

set(fig_handle,'Visible','on');
drawnow;
%
% end of show_stationarity.m
%
