function out = str2math(in)

%
% returns a numeric value from a potential mathematical expression
%

out = [];

if nargin==0;
   return;
end;

in = strtrim(in);
if strcmp(in,'')==1;
   return;
end;
if ischar(in)==0;
   return;
end;
%
ops = '';
%
% if in begins with + or - add '0' to in
%
if strcmp(in(1,1),'+')==1;
   in = ['0' in];
elseif strcmp(in(1,1),'-')==1;
   in = ['0' in];
elseif strcmp(in(1,1),'*')==1;
   in = in(1,2:size(in,2));
elseif strcmp(in(1,1),'/')==1;
   in = in(1,2:size(in,2));
elseif strcmp(in(1,1),'(')==1;
   in = in(1,2:size(in,2));
elseif strcmp(in(1,1),')')==1;
   in = in(1,2:size(in,2));
end;
%
in = strrep(in,',','.');
%
in = ['0+' in];
%
for i=1:size(in,2);
   if strcmp(in(1,i),'+')==1;
      in(1,i) = ' ';
      ops = strvcat(ops,'+');
   elseif strcmp(in(1,i),'-')==1;
      in(1,i) = ' ';
      ops = strvcat(ops,'-');
   elseif strcmp(in(1,i),'(')==1;
      in(1,i) = ' ';
   elseif strcmp(in(1,i),')')==1;
      in(1,i) = ' ';
   end;
end;
in = strtrim(in);
if isempty(findstr(in,' '))==0;
   in = vecstr(in);
   out = mystr2num(strtrim(in(1,:)));
   out1 = [];
   for i=2:size(in,1);
      ini = strtrim(in(i,:));
      outi = [];
      if isempty(findstr(ini,'/'))==0;
         ini = strrep(ini,'/',' ');
         ini = vecstr(ini);
         if size(ini,1)==2;
            out1 = mystr2num(strtrim(ini(1,:)));
            out2 = mystr2num(strtrim(ini(2,:)));
            if (isempty(out1)==0)&(isempty(out2)==0)&(isalmostequal(out2,0)==0);
               outi = out1/out2;
            end;
         else;
            out = [];
            return;
         end;
      elseif isempty(findstr(ini,'*'))==0;
         ini = strrep(ini,'*',' ');
         ini = vecstr(ini);
         if size(ini,1)==2;
            out1 = mystr2num(strtrim(ini(1,:)));
            out2 = mystr2num(strtrim(ini(2,:)));
            if (isempty(out1)==0)&(isempty(out2)==0);
               outi = out1*out2;
            end;
         else;
            out = [];
            return;
         end;
      else;
         outi = mystr2num(ini);
      end;
      %
      if isempty(outi)==0;
         if strcmp(ops(i-1,1),'+')==1;
            out1 = outi;
            out = out+outi;
         else;
            out1 = outi;
            out = out-outi;
         end;
      end;
   end;
   if (isempty(out)==0)&(isalmostequal(out,0)==1)&(isempty(out1)==1);
      out = [];
   end;
else;
   out = mystr2num(in);
end;

%
% end of str2math.m
%
