function toolbar_save_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

if ishandle(h)==1;
      thish = findobj('Tag','StructuralVAR');
   if isempty(thish)==1;
      thish = min(findobj('Type','figure')');
   end;
   model = get(thish,'UserData');
   if isempty(get(model.outputfile,'String'))==0;
      basedir = getpath(get(model.outputfile,'String'));
   else;
      basedir = pwd;
      if strcmp(computer,'PCWIN')==1;
         basedir = [basedir '\'];
      else;
         if isunix==1;
            basedir = [basedir '/'];
         else;
            basedir = [basedir '\'];
         end;
      end;
   end;
   if matlabnumber>=6.0;
      inputfiletype = cell(1,2);
      inputfiletype{1,1} = '*.fig';
      inputfiletype{1,2} = 'MatLab Figure Files (*.fig)';
   else;
      inputfiletype = [basedir '*.fig'];
   end;
   no_file = 1;
   if isempty(get(toolbar.name,'UserData'))==0;
      if ischar(get(toolbar.name,'UserData'))==1;
         this_name = get(toolbar.name,'UserData');
         if fileexist(this_name)==1;
            inputfiletype = this_name;
            no_file = 0;
         end;
      end;
   end;
   %
   % only show a save dialog if no_file flag is 1
   %
   if no_file==1;
      [filename,filepath] = uiputfile(inputfiletype,'Save');
      drawnow;
   else;
      filename = [getname(inputfiletype) '.fig'];
      filepath = getpath(inputfiletype);
   end;
   if isnumeric(filename)==0;
      %
      % check the file extension
      %
      file_ext = getext(filename);
      if strcmp(strtrim(file_ext),'')==1;
         file_ext = '.fig';
         filename = [filename '.fig'];
      end;
      if strcmp(lower(file_ext),'.fig')==1;
         old_pointer = get(h,'Pointer');
         if strcmp(old_pointer,'custom')==1;
            old_pointer_shape_cdata = get(h,'PointerShapeCData');
         end;
         set(h,'Pointer','watch');
         filename = [filepath filename];
         set(toolbar.name,'UserData',filename);
         %
         % we should be able to handle this better
         %
         mstat = saveas_fcn(h,filename);
         %
         set(toolbar.saveas,'UserData',0);
         set(h,'Pointer',old_pointer);
         if strcmp(old_pointer,'custom')==1;
            set(h,'PointerShapeCData',old_pointer_shape_cdata);
         end;
      else;
         txt_str = ['The save function can only save figures into the Matlab fig-file format. To save your graphics into another format, please use the "Save As" function instead.'];
         about(txt_str,'information','Illegal Format...',120,500);
      end;
   end;
else;
   setlogtext(strvcat(' ','Error: Current figure doesn''t have a handle! Unable to save...'));
end;

%
% end of toolbar_save_fcn.m
%
