function outmat = trace_exo_dist(n,q1,type_var,quantile)

%
% n = number of endogenous variables
% q1 = number of I(1) exogenous variables
% quantile = row in outmat
% type_var = distribution
%
% Critical values simulated with Structural VAR using sample size of 1000
% and 100,000 replications
%
%  Quantiles: 1% 2% 5% 10% 20%
%

outmat = [];
if strcmp(computer,'PCWIN')==1;
   file = [pwd '\mat\trace-quantile.mat'];
else;
   file = [pwd '/mat/trace-quantile.mat'];
end;
%
% load mat-file data if file exists
%
if fileexist(file)==0;
   return;
end;
a = load(file);
if type_var==[0 1 0 0];
   %
   % restricted constant
   %
   b = getfield(a,['trace_q_12_' num2str(q1,'%0.0f') '_rc']);
elseif type_var==[0 0 0 1];
   %
   % constant + restricted linear trend
   %
   b = getfield(a,['trace_q_12_' num2str(q1,'%0.0f') '_rt']);
else;
   return;
end;
b = b(1:n,quantile);

for i=1:n;
   outmat(i,1) = b(n-i+1,1);
end;

%
% end of trace_exo_dist.m
%
