%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                %
%          MatLab function for creating an mxn matrix            %
%          A by appending blocks of size m from an mnx1          %
%          vector a                                              %
%                                                                %
%          Function: vecinv                                      %
%                                                                %
%          Input:                                                %
%          		           a: mnx1 vector                          %
%                        m: number of rows for A                 %
%                                                                %
%          Output:                                               %
%                        A: mxn matrix                           %
%                                                                %
%          This version:        July 12, 2006                    %
%          Written by: 	        Anders Warne                     %
%                               Copyright (c) 2001-2006          %
%                                                                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function A = vecinv(a,m)

n = size(a,1)/m;
if n==floor(n);
   A = reshape(a,m,n);
else;
   A = 0;
end;

%A=0;
%if n==round(n);
%   if n>0;
%      i = 1;
%      A = zeros(m,n);
%      while i<=n;
%         A(:,i) = a(m*(i-1)+1:m*i,1);
%         i = i+1;
%      end;
%   end;
%end;

%
% end of function vecinv
%
